#include <stdio.h>
#include <string.h>
#include <graphics.h>
#include <dos.h>
#include <conio.h>
#include "pliers.h"
#include "stdlib.h"
#include "svga32k.h"
#include "svga64k.h"
#include "svgatc.h"

#include "svgautil.h"
#include "svgautil.c"

void setexclude(int x0,int y0,int x1,int y1)
{
  struct REGPACK regs;

  regs.r_ax = 0x10;
  regs.r_cx = x0;
  regs.r_dx = y0;
  regs.r_si = x1;
  regs.r_di = y1;
  intr(0x33,&regs);
}

/* Sets the regular 16x16 cursor */
void setpointer(char far *ptr)
{
  struct REGPACK regs;

  regs.r_ax = 9;
  regs.r_bx = 8;
  regs.r_cx = 8;
  regs.r_dx = FP_OFF(ptr);
  regs.r_es = FP_SEG(ptr);
  intr(0x33,&regs);
}

/* Sets the large mouse pointer */
void setlargepointer(char far *ptr)
{
  union REGS regs;
  struct SREGS sregs;

  regs.x.ax = 0x12;
  regs.x.dx = FP_OFF(ptr);
  regs.h.bh = 2;
  regs.h.ch = 16;
  regs.h.cl = 0;
  regs.h.bl = 0;
  sregs.es  = FP_SEG(ptr);
  int86x(0x33,&regs,&regs,&sregs);
}

void setmousepage(int z)
{
  union REGS regs;

  regs.x.ax = 0x1d;
  regs.x.bx = z;
  int86(0x33,&regs,&regs);
}

int initmouse()
{
  union REGS reg;

  reg.x.ax = 0x0;
  int86(0x33,&reg,&reg);
  return reg.x.ax;
}

void showmouse()
{
  union REGS reg;

  reg.x.ax = 0x1;
  int86(0x33,&reg,&reg);
}

void hidemouse()
{
  union REGS reg;

  reg.x.ax = 0x2;
  int86(0x33,&reg,&reg);
}

void setfgcolor(int r, int g, int b)
{
    union REGS reg;

    reg.x.ax = 0x4504;
    reg.h.cl = r;
    reg.h.bh = g;
    reg.h.bl = b;
    int86(0x33,&reg,&reg);
}

int getbuttonstate()
{
    union REGS reg;

    reg.x.ax = 0x5;
    int86(0x33, &reg, &reg);
    return reg.x.bx;
}

void far handler()
{
    static int yx;
    int    bstate = _BX;
    int    xc 	  = _CX;
    int    yc 	  = _DX;

    //setfgcolor(xc & 63, 0, yc & 63);
    if (bstate != 0) {
      if (bstate & 1) {
	outtextxy(0, yx+70, "LButton");
      }
      if (bstate & 2) {
	outtextxy(70, yx+70, "RButton");
      }
      yx += 10;
    }
}

void sethandler()
{
    union REGS regs;
    struct SREGS sregs;

    regs.x.ax = 0xC;
    regs.x.cx = 0xFF;
    regs.x.dx = FP_OFF(handler);
    sregs.es  = FP_SEG(handler);
    int86x(0x33, &regs, &regs, &sregs);
}

int huge Detect256(void)
{
  return 0;
}

char *drivers[] = {"svga16","svga256","svga32k","svga64k","svgatc",
		   "svgas3","twk16","twk256","egavga",""};

main()
{
  int gd,gm;
  int z,i;
  char c;
  int mod,mp,cp;
  char buf[60];
  int isMs, mx, my, yx;
  unsigned short maxc;

  gd = DETECT;
  for(z = i =0; *drivers[i] != '\0'; i++) {
      z += strlen(drivers[i])+4;
      if (z > 80) {
	  printf("\n");
	  z = 0;
      }
      printf("%d:%s  ", i, drivers[i]);
  }
  printf("\ndriver> ");
  scanf("%d",&z);
  if (z > i) z = i;
  if (z != i) gd = installuserdriver(drivers[z],Detect256);
  printf("Enter mode (-1 detects max mode):\n>");
  scanf("%d",&gm);
  if (gm < 0) {
    gm = 6;
    do {
      initgraph(&gd,&gm,"");
      gm--;
    } while (graphresult() != grOk);
  }
  else
    initgraph(&gd,&gm,"");
  gd = graphresult();
  if (gd != grOk) {
    printf("Error initializing driver! (%s)\n",grapherrormsg((char)gd));
    exit(1);
  }
  mod = 0;
  mp = 0;
  cp = 0;
  mx   = getmaxx();
  my   = getmaxy();
  maxc = getmaxcolor();

  if (maxc) {
    setfillstyle(BKSLASH_FILL, RealFillColor(RGB(24*8,0,0)));
    setcolor(RealDrawColor(RGB(0,20*8,0)));
  }
  else {
  /*
    setrgbpalette(4,63,0,0);
    setrgbpalette(15,63,63,63);
    setrgbpalette(2,0,63,0);
    setrgbpalette(1,0,0,63);*/
    setfillstyle(BKSLASH_FILL,4);
    setcolor(15);
  }
  /*
  for(i=31;i>0;i--) {
    setactivepage(i);
    setfillstyle(SLASH_FILL,i);
    bar(0,0,mx,getmaxy());
  }*/
  setactivepage(1);
  bar(0,0,mx,my);
  if (maxc > 256) {
    setfillstyle(XHATCH_FILL, RealFillColor(RGB(0,24*8,0)));
    setcolor(RealDrawColor(RGB(255,255,255)));
  }
  else {
    setfillstyle(XHATCH_FILL,2);
    setcolor(15);
  }
  setactivepage(0);
  bar(0,0,mx,my);
  line(0,0,mx,my);
  rectangle(mx>> 1,40,(3*mx) >> 2, 100);

  rectangle(0,128,31,128+31);

  if (maxc > 256) {
    setfillstyle(SOLID_FILL, RealFillColor(RGB(0,0,0)));
    setcolor(RealDrawColor(RGB(30*8, 30*8, 30*8)));
  }
  else {
    setfillstyle(SOLID_FILL,0);
    setcolor(15);
  }
  sprintf(buf,"Mode: %ux%ux%lu",mx+1,my+1,(long)maxc+1);
  bar(0,0,188,70);

  settextstyle(1,0,1);
  outtextxy(0,0,buf);
  outtextxy(0,10,"Commands: ");
  outtextxy(0,20,"p: Change visual page");
  outtextxy(0,30,"c: Change mouse pointer");
  outtextxy(0,40,"g: Change pointer page");
  outtextxy(0,50,"l: Large pointer");
  outtextxy(0,60,"q: Quit");
  if (maxc > 256)
    setfillstyle(SOLID_FILL, RealFillColor(RGB(28*8, 17*8, 10*8)));
  else
    setfillstyle(SOLID_FILL,1);

  bar(0,my >> 1, mx, my);

  isMs = initmouse();
  if (isMs) {
    showmouse();
    sethandler();

    z = 0;
    yx = 70;
    while(!z) {
      c = getch();
      switch(c) {
	case 'p':
	  mod++;
	  mod %= 32;
	  setvisualpage(mod);
	  break;
	case 's':
	  showmouse();
	  break;
	case 'h':
	  hidemouse();
	  break;
	case 'x':
	  setexclude(mx>>1,40,(3*mx)>>2,100);
	  break;
	case 'c':
	  hidemouse();
	  setpointer((char far *)cursor[cp]);
	  showmouse();
	  cp++;
	  cp %= 3;
	  break;
	case 'g':
	  mp++;
	  mp %= 2;
	  setmousepage(mp);
	  break;
	case 'l':
	  setlargepointer((char far *)Cursor);
	  break;
	case 'q':
	  z = 1;
	  break;
      }
    }
  }
  closegraph();
}