//--------------------------------------------------
// Header for color definitions
//--------------------------------------------------
// $Revision:   1.0  $
// $Date:   30 Mar 1993 18:20:28  $
//--------------------------------------------------

//------------------------------
// EARTH palette values
//------------------------------
#define EARTH_0           0   
#define EARTH_1          56    
#define EARTH_2           7    
#define EARTH_3          16    
#define EARTH_4           2    
#define EARTH_5          18    
#define EARTH_6           1    
#define EARTH_7           9    
#define EARTH_8          11    
#define EARTH_9          20    
#define EARTH_11         24    
#define EARTH_10          4    
#define EARTH_12          3    
#define EARTH_13         59    
#define EARTH_14         62    
#define EARTH_15         63    

//------------------------------
// EARTH palette names
//------------------------------
#define EARTH_BLACK       0
#define EARTH_DK_GRAY     1
#define EARTH_LT_GRAY     2
#define EARTH_DK_GREEN    3
#define EARTH_MED_GREEN   4
#define EARTH_LT_GREEN    5
#define EARTH_DK_BLUE     6
#define EARTH_MED_BLUE    7
#define EARTH_LT_BLUE     8
#define EARTH_BROWN       9 
#define EARTH_RED        10
#define EARTH_DK_CYAN    11
#define EARTH_MED_CYAN   12
#define EARTH_LT_CYAN    13
#define EARTH_YELLOW     14
#define EARTH_WHITE      15
                        
extern palettetype earth;

//------------------------------
// Dithered colors
//------------------------------
typedef char near CN, near *CNP;
struct color
{
  int rows;
  CNP planes[4];
  char dummy[6];
};
extern CN dither[];

// EARTH palette dither patterns
extern CNP granite_1[];
extern struct color granite[];

//------------------------------
// Solid color-pair description
//------------------------------
struct color_mix
{
  int c1;
  int c2;
};
extern color_mix colors[];

// Solid color sets
#define EGA_COLORS       155
extern color_mix ega_colors[];
#define EARTH_COLORS     224
extern color_mix earth_colors[];
