// 3DS OBJECT POINT RENDERING

#include <iostream.h>
#include <conio.h>
#include <grafx2.cpp>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <timer.cpp>
#include <string.h>

char key;
int lx[500],ly[500],lz[500];
int face[500][3];
int nbp=0,nbf=0,ti=0;

void LoadASC(char *nom)
{
  FILE  *fichier;
  char  chaine[200];
  char  *fin;
  int   i,j;
  char  temp[50];
  float x,y,z;
  int   a,b,c;
  int   decalage=0;

  if ((fichier = fopen(nom,"rt"))==NULL)
  {
    perror("Impossible d'ouvrir le fichier en lecture");
    exit(-2);
  }

  do
  {
    // On lit le fichier contenant les informations sur l'objet
    fin=fgets(chaine,100,fichier);
    if (!strncmp(chaine,"Vertex",6))
    {
      if (strncmp(chaine,"Vertex list",11))
      {
	// Lecture des coordonnes d'un point
	i=0;

	while(chaine[i]!='X') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&x);

	while(chaine[i]!='Y') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&y);

	while(chaine[i]!='Z') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&z);

	lx[nbp]=x/16;
	ly[nbp]=y/16;
	lz[nbp]=z/16;
	nbp++;
      }
    }

    /*else
    {
      if (!strncmp(chaine,"Face",4))
      {
	if (strncmp(chaine,"Face list",9))
	{
	  // Lecture d'une facette
	  i=j=0;
	  while(chaine[i]!='A') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][1]=atoi(temp)+decalage;

	  while(chaine[i]!='B') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][2]=atoi(temp)+decalage;

	  while(chaine[i]!='C') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][3]=atoi(temp)+decalage;

	  // Lecture des artes visibles
	  while(chaine[i]!='A') i++;

	  strncpy(temp,chaine+i+3,1);
	  temp[j-i]=0;
	  Facette[Nb_faces].ab=atoi(temp);

	  strncpy(temp,chaine+i+8,1);
	  temp[j-i]=0;
	  Facette[Nb_faces].bc=atoi(temp);

	  strncpy(temp,chaine+i+13,1);
	  temp[j-i]=0;
	  Facette[Nb_faces].ac=atoi(temp);

	  nbf++;
	}
      }
      else
	if (!strncmp(chaine,"Named object",12))
	  decalage=nbp;
    }*/
  } while(fin!=NULL);


  fclose(fichier);
}

int lxn[500],lyn[500],lzn[500];
int xd[500],yd[500];
int xt,yt,zt;
int ax,ay,az,axnew,aynew,aznew;
int xsin,xcos,ysin,ycos,zsin,zcos;

main()
{
LoadASC("duck.asc");
printf("%d",nbp);
getch();
Timer w;
SetVirtual();
SetVGA();
w.reset();

for(int zz=0;zz<25;zz++)
printf("\n%d",lx[zz]);
getch();

ax=0;
ay=0;
az=0;

//CALC SIN COS TABLE

int sine[256];
int cose[256];

for(int i=0;i<256;i++)
{
sine[i]=(sin(i*0.02454))*128;
cose[i]=(cos(i*0.02454))*128;
}

do
{

w.start();
ti++;
if(kbhit())
key=getch();

ax+=1;
ay+=1;
az+=1;

axnew=ax-(((int)(ax>>8)) << 8);
aynew=ay-(((int)(ay>>8)) << 8);
aznew=az-(((int)(az>>8)) << 8);

for(int n=0;n<nbp;n++)
{

xsin = sine[axnew];
xcos = cose[axnew];
ysin = sine[aynew];
ycos = cose[aynew];
zsin = sine[aznew];
zcos = cose[aznew];

yt     = ((ly[n] * xcos - lz[n] *  xsin) >> 7);
zt     = ((ly[n] * xsin + lz[n] *  xcos) >> 7);
xt     = ((lx[n] * ycos - zt * ysin) >> 7);
lzn[n] = ((lx[n] * ysin + zt * ycos) >> 7);
lxn[n] = ((xt * zcos - yt *  zsin) >> 7);
lyn[n] = ((xt * zsin + yt *  zcos) >> 7);

xd[n]=160+(lxn[n] << 7)/(lzn[n]+300);
yd[n]=100+(lyn[n] << 7)/(lzn[n]+300);
}

Cls(vaddr,0);

for(int mb=0;mb<nbp;mb++)
{
//if(xd[mb]>0 && xd[mb]<320)
//if(yd[mb]>0 && yd[mb]<200)
Putpixel(xd[mb],yd[mb],11,vaddr);
}

Flip(vaddr,vga);

}
while(key!=27);
w.stop();
printf("*** FPS REPORT ***\n");
printf("secondes coules: %f\n",w.time());
printf("frames affiches: %d\n",ti);
printf("frame/seconde: %f\n",ti/w.time());
getch();
FreeVirtual();
}
