//3DS OBJECT WIREFRAME RENDERING

#include <iostream.h>
#include <conio.h>
#include <grafx2.cpp>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <timer.cpp>
#include <string.h>

char key;
int coor[1000][3];
int face[1000][3];
unsigned int nbpt,test,nbf,ti,nbp;

unsigned char far buffer[64000];

void LoadASC(char *nom)
{
  FILE  *fichier;
  char  chaine[200];
  char  *fin;
  int   i,j;
  char  temp[50];
  float x,y,z;
  int   a,b,c;
  int   decalage=0;

  nbpt=0;
  test=0;
  nbf=0;
  nbp=0;

  if ((fichier = fopen(nom,"rt"))==NULL)
  {
    perror("Impossible d'ouvrir le fichier en lecture");
    exit(-2);
  }

  do
  {
    // On lit le fichier contenant les informations sur l'objet
    fin=fgets(chaine,100,fichier);
    if (!strncmp(chaine,"Vertex",6))
    {
      if (strncmp(chaine,"Vertex list",11))
      {
	// Lecture des coordonnes d'un point
	i=0;

	while(chaine[i]!='X') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&x);

	while(chaine[i]!='Y') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&y);

	while(chaine[i]!='Z') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&z);

	coor[nbp][0]=x/16;
	coor[nbp][1]=y/16;
	coor[nbp][2]=z/16;

	nbp++;
      }
    }

    else
    {
      if (!strncmp(chaine,"Face",4))
      {
	if (strncmp(chaine,"Face list",9))
	{
	  // Lecture d'une facette
	  i=j=0;
	  while(chaine[i]!='A') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][0]=atoi(temp)+decalage;

	  while(chaine[i]!='B') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][1]=atoi(temp)+decalage;

	  while(chaine[i]!='C') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][2]=atoi(temp)+decalage;

	  nbf++;
	  }
	}
      else
	if (!strncmp(chaine,"Named object",12))
	  decalage=nbp;
    }
  } while(fin!=NULL);


  fclose(fichier);
}

int lxn[500],lyn[500],lzn[500];
int xd[500],yd[500];
float ax,ay,az;
float mr[3][3];

main()
{
LoadASC("torus.asc");
printf("points:%d - faces:%d",nbp,nbf);
getch();
Timer w;
SetVGA();
w.reset();
word vram;
vram=FP_SEG(buffer);

ax=0;
ay=0;
az=0;

do
{

w.start();
ti++;
if(kbhit())
key=getch();

ax=ax+0.005;
ay=ay+0.005;
az=az+0.004;

mr[0][0] = cos(az)*cos(ay);
mr[1][0] = sin(az)*cos(ay);
mr[2][0] = -sin(ay);
mr[0][1] = cos(az)*sin(ay)*sin(ax)-sin(az)*cos(ax);
mr[1][1] = sin(az)*sin(ay)*sin(ax)+cos(ax)*cos(az);
mr[2][1] = sin(ax)*cos(ay);
mr[0][2] = cos(az)*sin(ay)*cos(ax)+sin(az)*sin(ax);
mr[1][2] = sin(az)*sin(ay)*cos(ax)-cos(az)*sin(ax);
mr[2][2] = cos(ax)*cos(ay);

for(int n=0;n<nbp;n++)
{
lxn[n]=coor[n][0]*mr[0][0]+coor[n][1]*mr[1][0]+coor[n][2]*mr[2][0];
lyn[n]=coor[n][0]*mr[0][1]+coor[n][1]*mr[1][1]+coor[n][2]*mr[2][1];
lzn[n]=coor[n][0]*mr[0][2]+coor[n][1]*mr[1][2]+coor[n][3]*mr[2][2];
xd[n]=160+(lxn[n] << 7)/(lzn[n]+30);
yd[n]=100+(lyn[n] << 7)/(lzn[n]+30);
}

Cls(vram,0);

for(int mb=0;mb<nbf;mb+=2)
{
//Putpixel(xd[mb],yd[mb],11,vaddr);
Line(xd[face[mb][0]],yd[face[mb][0]],xd[face[mb][1]],yd[face[mb][1]],11,vram);
Line(xd[face[mb][1]],yd[face[mb][1]],xd[face[mb][2]],yd[face[mb][2]],11,vram);
Line(xd[face[mb][2]],yd[face[mb][2]],xd[face[mb][0]],yd[face[mb][0]],11,vram);
}

Flip(vram,vga);

}
while(key!=27);
w.stop();
printf("*** FPS REPORT ***\n");
printf("secondes coules: %f\n",w.time());
printf("frames affiches: %d\n",ti);
printf("frame/seconde: %f\n",ti/w.time());
getch();
}
