//3DS OBJET FLAT FILLING

#include <iostream.h>
#include <conio.h>
#include <grafx2.cpp>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <timer.cpp>
#include <string.h>
#include <flibb.cpp>
//#include <palette2.cpp>

unsigned char far vs[64000];
char key;
int coor[500][3];
int face[1000][3];
int ptface[500][5];
int cpt[500];
int fn[1000][4];
int pn[500][4],pnr[500][3];
int lxr[500],lyr[500],lzr[500];
int xd[500],yd[500];

int nbf,nbp,ti;

int tri[1000];
int zface[1000];


//QUICK SORT ROUTINE
void QuickSort(int deb, int fin)
{
  int   i=deb;
  int   j=fin;
  double milieu=256*zface[tri[(deb+fin)/2]];
  int   temp;

  while(i<=j)
  {
    while(256*zface[tri[i]]> milieu) i++;
    while(256*zface[tri[j]]< milieu) j--;

    if(i<=j)
    {
      temp=tri[i];
      tri[i]=tri[j];
      tri[j]=temp;
      i++; j--;
    }
  }

  if(i<fin) QuickSort(i,fin);
  if(deb<j) QuickSort(deb,j);
}



///3DS READER
void LoadASC(char *nom)
{
  FILE  *fichier;
  char  chaine[200];
  char  *fin;
  int   i,j;
  char  temp[50];
  float x,y,z;
  int   a,b,c;
  int   decalage=0;

  //nbpt=0;
  //test=0;
  nbf=0;
  nbp=0;

  if ((fichier = fopen(nom,"rt"))==NULL)
  {
    perror("Impossible d'ouvrir le fichier en lecture");
    exit(-2);
  }

  do
  {
    // On lit le fichier contenant les informations sur l'objet
    fin=fgets(chaine,100,fichier);
    if (!strncmp(chaine,"Vertex",6))
    {
      if (strncmp(chaine,"Vertex list",11))
      {
	// Lecture des coordonnes d'un point
	i=0;

	while(chaine[i]!='X') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&x);

	while(chaine[i]!='Y') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&y);

	while(chaine[i]!='Z') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&z);

	coor[nbp][0]=x/16;
	coor[nbp][1]=y/16;
	coor[nbp][2]=z/16;

	nbp++;
      }
    }

    else
    {
      if (!strncmp(chaine,"Face",4))
      {
	if (strncmp(chaine,"Face list",9))
	{
	  // Lecture d'une facette
	  i=j=0;
	  while(chaine[i]!='A') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][0]=atoi(temp)+decalage;

	  while(chaine[i]!='B') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][1]=atoi(temp)+decalage;

	  while(chaine[i]!='C') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][2]=atoi(temp)+decalage;

	  nbf++;
	  }
	}
      else
	if (!strncmp(chaine,"Named object",12))
	  decalage=nbp;
    }
  } while(fin!=NULL);


  fclose(fichier);


for(a=0;a<nbp;a++)
cpt[a]=0;


for(a=0;a<nbp;a++)
for(b=0;b<nbf;b++)
if(face[b][1]==a || face[b][0]==a || face[b][2]==a)
{
ptface[a][cpt[a]]=b;
if(cpt[a]<4)
cpt[a]++;
}
}


//PALETTE
void PrePal(void)
{
/*float r;
for(int i=32;i<224;i++)
{
SetPal(i,r,r,r);
r+=0.3 ;*/
float r=0,g=0,b=0;
short i;
for(i=32;i<256;i++)
SetPal(i,0,0,0);
//SetPal(0,0,0,20);
for(i=0;i<100;i++)
{
SetPal(i,r,0,0);
r+=0.5;
}
for(i=100;i<128;i++)
{
SetPal(i,r,g,b);
r+=0.5;
g+=2;
b+=2;
}
r=0,g=0,b=0;
for(i=128;i<228;i++)
{
SetPal(i,0,0,b);
b+=0.5;
}
for(i=228;i<256;i++)
{
SetPal(i,r,g,b);
b+=0.5;
g+=2;
r+=2;
}
SetPal(7,63,63,63);
}


float ax,ay,az;
int mr[3][3];
int znm,facev;
point points[3];


main()
{

Timer w;
SetVGA();
PrePal();
word vadd = FP_SEG(vs);
w.reset();

LoadASC("duck.asc");
printf("points:%d - faces:%d",nbp,nbf);

int a,b,i;

for(a=0;a<256;a++)
Line(a,0,a,200,a,vga);
getch();

int lux,luy,luz;
int lun,lint1,lint2,lint3;

lux=0;
luy=0;
luz=-5;
lun=sqrt(lux*lux+luy*luy+luz*luz);

float aa[3],bb[3];

for(a=0;a<nbf;a++)
{
aa[0] = (coor[face[a][0]][0]-coor[face[a][1]][0]);
aa[1] = (coor[face[a][0]][1]-coor[face[a][1]][1]);
aa[2] = (coor[face[a][0]][2]-coor[face[a][1]][2]);
bb[0] = (coor[face[a][0]][0]-coor[face[a][2]][0]);
bb[1] = (coor[face[a][0]][1]-coor[face[a][2]][1]);
bb[2] = (coor[face[a][0]][2]-coor[face[a][2]][2]);
fn[a][0] = (aa[1]*bb[2]-aa[2]*bb[1])/5;
fn[a][1] = (aa[2]*bb[0]-aa[0]*bb[2])/5;
fn[a][2] = (aa[0]*bb[1]-aa[1]*bb[0])/5;

b=((fn[a][0]*fn[a][0])>>6)+((fn[a][1]*fn[a][1])>>6)+((fn[a][2]*fn[a][2])>>6);
if(b<0)
printf("\nOBJET ERROR!%d,%d,%d,%d  (%d)",fn[a][0]*fn[a][0],fn[a][1]*fn[a][1],fn[a][2]*fn[a][2],b,a);

fn[a][3] = sqrt((fn[a][0]*fn[a][0])+(fn[a][1]*fn[a][1])/16+(fn[a][2]*fn[a][2])/16);
}


for(a=0;a<nbp;a++)
{
pn[a][0]=0;
pn[a][1]=0;
pn[a][2]=0;
pn[a][3]=0;

for(b=0;b<cpt[a];b++)
{
pn[a][0]+=fn[ptface[a][b]][0];
pn[a][1]+=fn[ptface[a][b]][1];
pn[a][2]+=fn[ptface[a][b]][2];
pn[a][3]+=fn[ptface[a][b]][3];
}

pn[a][0]/=(cpt[a]+1);
pn[a][1]/=(cpt[a]+1);
pn[a][2]/=(cpt[a]+1);
pn[a][3]/=(cpt[a]+1);
pn[a][3]++;
}

for(a=0;a<nbp;a++)
if(pn[a][3]<1)
printf("\nERROR%d -> %d ",a,pn[a][3]);

getch();


ax=4.7;
ay=0;
az=1.57;

do
{

w.start();
ti++;
if(kbhit())
key=getch();

ax+=0.004;
ay+=0.003;
az+=0.005;

mr[0][0] = (cos(az)*cos(ay)                        )*128;
mr[1][0] = (sin(az)*cos(ay)                        )*128;
mr[2][0] = (-sin(ay)                               )*128;
mr[0][1] = (cos(az)*sin(ay)*sin(ax)-sin(az)*cos(ax))*128;
mr[1][1] = (sin(az)*sin(ay)*sin(ax)+cos(ax)*cos(az))*128;
mr[2][1] = (sin(ax)*cos(ay)                        )*128;
mr[0][2] = (cos(az)*sin(ay)*cos(ax)+sin(az)*sin(ax))*128;
mr[1][2] = (sin(az)*sin(ay)*cos(ax)-cos(az)*sin(ax))*128;
mr[2][2] = (cos(ax)*cos(ay)                        )*128;



for(int n=0;n<nbp;n++)
{
pnr[n][0]=((pn[n][0]*mr[0][0]+pn[n][1]*mr[1][0]+pn[n][2]*mr[2][0]) >> 7);
pnr[n][1]=((pn[n][0]*mr[0][1]+pn[n][1]*mr[1][1]+pn[n][2]*mr[2][1]) >> 7);
pnr[n][2]=((pn[n][0]*mr[0][2]+pn[n][1]*mr[1][2]+pn[n][2]*mr[2][2]) >> 7);

lxr[n]=((coor[n][0]*mr[0][0]+coor[n][1]*mr[1][0]+coor[n][2]*mr[2][0]) >> 7);
lyr[n]=((coor[n][0]*mr[0][1]+coor[n][1]*mr[1][1]+coor[n][2]*mr[2][1]) >> 7);
lzr[n]=((coor[n][0]*mr[0][2]+coor[n][1]*mr[1][2]+coor[n][2]*mr[2][2]) >> 7);

if(lzr[n]>-250)
{
xd[n]=160+(160*lxr[n])/(lzr[n]+250);
yd[n]=100+(100*lyr[n])/(lzr[n]+250);
}
}


Cls(vadd,0);

/*for(n=0;n<nbp;n++)
{
if(xd[n]>0 && xd[n]<320)
if(yd[n]>0 && yd[n]<200)
Putpixel(xd[n],yd[n],5,vadd);
}*/

int facev=0;
for(int m=0;m<nbf;m++)
{
znm=(xd[face[m][1]]-xd[face[m][0]])*(yd[face[m][0]]-yd[face[m][2]])-(yd[face[m][1]]-yd[face[m][0]])*(xd[face[m][0]]-xd[face[m][2]]);
//znm=2; //only zsorting
if(znm>0)
{
zface[m]=(lzr[face[m][0]]+lzr[face[m][1]]+lzr[face[m][2]]+750);
//if(zface[m]<10)
//printf("\n%d",zface[m]);

tri[facev]=m;
facev++;
}
}
QuickSort(0,facev-1);

for(int mb=0;mb<facev;mb++)
{

/*if(mb==36 && ti==28)
{
printf("\nWARNING:%d, %d, %d   !",pn[face[tri[mb]][0]][3],pn[face[tri[mb]][1]][3],pn[face[tri[mb]][2]][3]);
printf("\nrang %d, %d , tri:%d",ti,mb,tri[mb]);
printf("\nWARNING:%d, %d, %d   !",pnr[face[tri[mb]][0]][0]*lux+pnr[face[tri[mb]][0]][1]*luy+pnr[face[tri[mb]][0]][2]*luz
				 ,pnr[face[tri[mb]][1]][0]*lux+pnr[face[tri[mb]][1]][1]*luy+pnr[face[tri[mb]][1]][2]*luz
				 ,pnr[face[tri[mb]][2]][0]*lux+pnr[face[tri[mb]][2]][1]*luy+pnr[face[tri[mb]][2]][2]*luz);



getch();
}*/

lint1=((pnr[face[tri[mb]][0]][0]*lux+pnr[face[tri[mb]][0]][1]*luy+pnr[face[tri[mb]][0]][2]*luz)<<5)/(lun*pn[face[tri[mb]][0]][3]);
lint2=((pnr[face[tri[mb]][1]][0]*lux+pnr[face[tri[mb]][1]][1]*luy+pnr[face[tri[mb]][1]][2]*luz)<<5)/(lun*pn[face[tri[mb]][1]][3]);
lint3=((pnr[face[tri[mb]][2]][0]*lux+pnr[face[tri[mb]][2]][1]*luy+pnr[face[tri[mb]][2]][2]*luz)<<5)/(lun*pn[face[tri[mb]][2]][3]);

/*if(mb==36 && ti==28)
{
printf("PASSED!");
getch();
}*/

//printf("\r%d of %d (%d)  :",mb,facev,ti);
//lint=(nxr[tri[mb]]*lux+nyr[tri[mb]]*luy+nzr[tri[mb]]*luz)/(lun*nn[tri[mb]]);
//if( mb==30)
//printf("%d,%d,%d     ",lint1,lint2,lint3);
//if(ti==28)
//getch();



//printf("\r%d,%d,%d  ;%d    ",pnr[face[5][0]][0],pnr[face[5][0]][1],pnr[face[5][0]][2],pn[face[5][0]][3]);
//getch();

points[0].x = xd[face[tri[mb]][0]];
points[0].y = yd[face[tri[mb]][0]];
points[0].col = 90+lint1;
points[1].x = xd[face[tri[mb]][1]];
points[1].y = yd[face[tri[mb]][1]];
points[1].col = 90+lint2;
points[2].x = xd[face[tri[mb]][2]];
points[2].y = yd[face[tri[mb]][2]];
points[2].col = 90+lint3;
FillPoly(points,3,vadd);

//Flip(vadd,vga);
//getch();

}

//getch();
Flip(vadd,vga);

}
while(key!=27);


w.stop();
SetPal(7,63,63,63);
printf("\n*** FPS REPORT ***\n");
printf("secondes coules: %f\n",w.time());
printf("frames affiches: %d\n",ti);
printf("frame/seconde: %f\n",ti/w.time());
getch();
}

