#include "stdio.h"
#include "conio.h"
#include "graphics.h"
#include "process.h"
#include "stdlib.h"
#include "dos.h"
#include "math.h"

void presentacion();
void informacion();
void botonundido(int x, int y, int ancho, int alto, char texto[]);
void botonnoundido(int x, int y, int ancho, int alto, char texto[]);
void canon1(int x, int y);
void canon2(int x, int y);
void iniciargraficos();
void juego();
void datos(int a, float *b);
void disparar(int canon, float vo, float ang, int hc1, int hc2);
void explotarcanon(int canon, int hdc);

void main()
{
 int teclapresionada;
 randomize();
 iniciargraficos();
 presentacion();
 informacion();
 settextjustify(CENTER_TEXT, CENTER_TEXT);
 juego();
}

void iniciargraficos()
{
 int gdriver=DETECT, gmode, error;
 initgraph(&gdriver, &gmode, "c:\\borlandc\\bgi");
 error=graphresult();
 if(error!=0)
    {
     printf("Error al iniciar los graficos.\nPresione alguna tecla para continuar.");
     getch();
     exit(0);
    }
 return;
}

void informacion()
{
 int h=60;

 cleardevice();
 setfillstyle(1,15);
 bar(0,0,640,480);
 setcolor(1);
 settextstyle(2,0,4);
 outtextxy(100,h,"INFORMACION:");
 outtextxy(100,h*2,"Presione <A> para digitar el angulo de elevacion.");
 outtextxy(100,h*3,"Presione <V> para digitar la velocidad inicial.");
 outtextxy(100,h*4,"Presione <D> para disparar.");
 outtextxy(100,h*5,"Presione <C> para cambiar las posiciones de los caones.");
 outtextxy(100,h*6,"Presione <ESC> para salir.");
 outtextxy(100,h*7,"Presione alguna tecla para continuar.");
 getch();
 return;
}

void presentacion()
{
 cleardevice();
 setfillstyle(1,1);
 bar(0,0,640,480);
 settextstyle(4,0,5);
 setcolor(15);
 outtextxy(150,100,"BIENVENIDOS A:");
 settextstyle(4,0,6);
 outtextxy(50,300,"SUPER CAONCITOS");
 delay(3000);
 return;
}

void juego()
{
 int turno=1, tecla, permiso=0, ganador;
 float hc1, hc2,vo=0, ang=-1;
 hc1=random(420)+10;
 delay(5);
 hc2=random(420)+10;
 cambiarturno:
 setfillstyle(1,9);
 bar(0,0,640,480);
 settextstyle(0,0,1);
 setcolor(15);
 if(turno==1)
   {
    setfillstyle(1,9);
    bar(20,hc1+20,40,hc1+30);
    outtextxy(50,hc1+60,"TURNO");
   }
 else
   {
    setfillstyle(1,9);
    bar(580,hc2+20,600,hc2+30);
    outtextxy(610,hc2+60,"TURNO");
   }
 setcolor(15);
 canon1(30,hc1);
 canon2(590,hc2);
 do
 {
  botonnoundido(140, 30, 100, 30, "(A)ngulo");
  botonnoundido(260, 30, 100, 30, "(V). inicial");
  botonnoundido(380, 30, 100, 30, "(D)isparar");
  botonnoundido(200, 80, 100, 30, "(C)ambiar");
  botonnoundido(325, 80, 100, 30, "(ESC)ape");
  do
  {
   tecla=getch();
  }
  while((tecla!='A')&&(tecla!='a')&&(tecla!='V')&&(tecla!='v')&&(tecla!='D')&&(tecla!='d')&&(tecla!=27)&&(tecla!='C')&&(tecla!='c'));
  switch(tecla)
  {
   case 'A':
   case 'a':
     botonundido(140, 30, 100, 30, "(A)ngulo");
     delay(200);
     botonnoundido(140, 30, 100, 30, "(A)ngulo");
     delay(200);
     datos(1, &ang);
     break;
   case 'V':
   case 'v':
     botonundido(260, 30, 100, 30, "(V). inicial");
     delay(200);
     botonnoundido(260, 30, 100, 30, "(V). inicial");
     delay(200);
     datos(2, &vo);
     break;
   case 'D':
   case 'd':
     botonundido(380, 30, 100, 30, "(D)isparar");
     delay(200);
     botonnoundido(380, 30, 100, 30, "(D)isparar");
     delay(200);
     if((ang!=-1)&&(vo!=0))
         permiso=1;
     break;
   case 'C':
   case 'c':
     botonundido(200, 80, 100, 30, "(C)ambiar");
     delay(200);
     botonnoundido(200, 80, 100, 30, "(C)ambiar");
     delay(200);
     juego();
   case 27:
     botonundido(325, 80, 100, 30, "(ESC)ape");
     delay(200);
     botonnoundido(325, 80, 100, 30, "(ESC)ape");
     delay(200);
     closegraph();
     exit(0);
  }
 }
 while(permiso!=1);
 disparar(turno, vo, ang, hc1, hc2);
 permiso=0;
 if(turno==1)
    turno=2;
 else
    turno=1;
 goto cambiarturno;
}

void botonundido(int x, int y, int ancho, int alto, char texto[])
{
 int cuadro[8];
 setfillstyle(1,0);
 cuadro[0]=x;
 cuadro[1]=y;
 cuadro[2]=x+ancho;
 cuadro[3]=y;
 cuadro[4]=x+ancho;
 cuadro[5]=y+alto;
 cuadro[6]=x;
 cuadro[7]=y+alto;
 fillpoly(4, cuadro);
 setcolor(15);
 line(x,y,x+ancho,y);
 line(x,y,x,y+alto);
 setcolor(7);
 line(x+ancho,y,x+ancho,y+alto);
 line(x,y+alto,x+ancho,y+alto);
 line(x+ancho-1,y,x+ancho-1,y+alto);
 line(x,y+alto-1,x+ancho,y+alto-1);
 setcolor(15);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 outtextxy(x+ancho/2,y+alto/2, texto);
}

void botonnoundido(int x, int y, int ancho, int alto, char texto[])
{
 int cuadro[8];
 setfillstyle(1,0);
 cuadro[0]=x;
 cuadro[1]=y;
 cuadro[2]=x+ancho;
 cuadro[3]=y;
 cuadro[4]=x+ancho;
 cuadro[5]=y+alto;
 cuadro[6]=x;
 cuadro[7]=y+alto;
 fillpoly(4, cuadro);
 setcolor(15);
 line(x,y,x+ancho,y);
 line(x,y,x,y+alto);
 line(x+1,y+1,x+ancho,y+1);
 line(x+1,y+1,x+1,y+alto);
 setcolor(7);
 line(x+ancho,y,x+ancho,y+alto);
 line(x,y+alto,x+ancho,y+alto);
 setcolor(15);
 settextjustify(CENTER_TEXT,CENTER_TEXT);
 outtextxy(x+ancho/2,y+alto/2, texto);
}

void canon1(int x, int y)
{
 int tubo[8], base[8];
 setfillstyle(1,1);
 tubo[0]=x+37;
 tubo[1]=y+10;
 tubo[2]=x+40;
 tubo[3]=y+15;
 tubo[4]=x+20;
 tubo[5]=y+25;
 tubo[6]=x+15;
 tubo[7]=y+20;
 fillpoly(4,tubo);
 setfillstyle(1,0);
 base[0]=x+0;
 base[1]=y+35;
 base[2]=x+40;
 base[3]=y+35;
 base[4]=x+40;
 base[5]=y+40;
 base[6]=x+0;
 base[7]=y+40;
 fillpoly(4,base);
 setfillstyle(1,14);
 fillellipse(x+20,y+25,10,10);
 setfillstyle(1,0);
 fillellipse(x+20,y+25,3,3);
}

void canon2(int x, int y)
{
 int tubo[8], base[8];
 setfillstyle(1,1);
 tubo[0]=x+3;
 tubo[1]=y+10;
 tubo[2]=x;
 tubo[3]=y+15;
 tubo[4]=x+20;
 tubo[5]=y+25;
 tubo[6]=x+25;
 tubo[7]=y+20;
 fillpoly(4,tubo);
 setfillstyle(1,0);
 base[0]=x+40;
 base[1]=y+35;
 base[2]=x+0;
 base[3]=y+35;
 base[4]=x+0;
 base[5]=y+40;
 base[6]=x+40;
 base[7]=y+40;
 fillpoly(4,base);
 setfillstyle(1,7);
 fillellipse(x+20,y+25,10,10);
 setfillstyle(1,0);
 fillellipse(x+20,y+25,3,3);
}

void datos (int a, float *b)
{
 setcolor(7);
 rectangle(100,200,520,280);
 setfillstyle(1,0);
 bar(101,201,519,279);
 if(a==1)
    {
     gotoxy(25,15);
     printf("Digite el angulo (de 0 a 89): ");
    }
 else
    {
     gotoxy(16,15);
     printf("Digite la velocidad inicial (mayor que 0): ");
    }
 if(a==1)
    {
     scanf("%f", b);
     if((*b<0)||(*b>89))
  {
   gotoxy(25,16);
   printf("Angulo Incorrecto.");
   getch();
   *b=-1;
  }
    }
 if(a==2)
    {
     scanf("%f", b);
     if(*b<=0)
 {
  gotoxy(16,16);
  printf("Velocidad inicial Incorrecta.");
  getch();
  *b=0;
 }
    }
 setfillstyle(1,9);
 bar(100,200,550,280);
}

void disparar(int canon, float vo, float ang, int hc1, int hc2)
{
 float y, g=9.8, dist;
 int i;

 setfillstyle(1,9);
 bar(100,0,550,200);
 ang=ang*3.1416/180;
 setcolor(15);
 if(canon==1)
    {
     moveto(50,hc1-y+20);
     for(i=30;i<=640;i++)
  {
   dist=i-30;
   y=(dist*tan(ang))-((g*dist*dist)/(2*vo*vo*cos(ang)*cos(ang)));
   y=hc1-y+20;
   lineto(i+20,y);
   if((i>=580)&&(i<600)&&(y>=hc2+15)&&(y<=hc2+35))
       {
        explotarcanon(2,hc2);
        break;
       }
   if(y>480)
      break;
   delay(10);
  }
    }
 else
    {
     if(canon==2)
 {
  moveto(610,hc2-y+20);
  for(i=590;i>=-100;i--)
      {
       dist=-(i-590);
       y=(dist*tan(ang))-((g*dist*dist)/(2*vo*vo*cos(ang)*cos(ang)));
       y=hc2-y+20;
       lineto(i+20,y);
       if((i>=20)&&(i<=40)&&(y>=hc1+15)&&(y<=hc1+35))
    {
     explotarcanon(1,hc1);
     break;
    }
       if(y>480)
   break;
       delay(10);
      }
 }
    }
}

void explotarcanon(int canon, int hdc)
{
 int i,color, st, tecla;
 setcolor(8);
 for(i=0;i<=300;i++)
     {
      st=random(2);
      if(st==1)
  setfillstyle(1,4);
      else
  setfillstyle(1,14);
      if(canon==1)
  fillellipse(30+random(40),hdc+random(40), random(3)+3, random(3)+3);
      else
  fillellipse(590+random(40),hdc+random(40), random(3)+3, random(3)+3);
      sound(random(500)+50);
      delay(5);
     }
 nosound();
 setcolor(7);
 rectangle(130,200,500,280);
 setfillstyle(1,0);
 bar(131,201,499,279);
 gotoxy(28,15);
 printf("Desea volver a jugar (S/N): ");
 do
 {
  tecla=getch();
 }
 while((tecla!='S')&&(tecla!='s')&&(tecla!='N')&&(tecla!='n'));
 if((tecla=='S')||(tecla=='s'))
     juego();
 else
     {
      closegraph();
      exit(0);
     }
}