// MOTION TEXTURE MAPPING

#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

unsigned char far image[16384];

#include <grafx2.cpp>
//#include <pcx2.cpp>
#include <timer.cpp>
#include <flib4.cpp>
#include <qsort.cpp>
#include <info.cpp>

int key;
float ax=0.0,ay=0.0,az=0.0;
float mr[3][3];
float c=2;  //zoom
short lx[8]={1,1,1,1,-1,-1,-1,-1};
short ly[8]={1,1,-1,-1,1,1,-1,-1};
short lz[8]={1,-1,1,-1,1,-1,1,-1};
float lxn[8],lyn[8],lzn[8];
float xd[8],yd[8];

face[12][3]= {{5,1,3},{7,5,3},{1,0,2},{3,1,2},{0,4,6},{2,0,6},{4,5,7},{6,4,7},{4,0,1},{5,4,1},{7,3,2},{6,7,2}};
faceut[12][3]={{0,127,127},{0,0,127},{0,127,127},{0,0,127},{0,127,127},{0,0,127},{0,127,127},{0,0,127},{0,127,127},{0,0,127},{0,127,127},{0,0,127}};
facevt[12][3]={{0,0,127},{127,0,127},{0,0,127},{127,0,127},{0,0,127},{127,0,127},{0,0,127},{127,0,127},{0,0,127},{127,0,127},{0,0,127},{127,0,127}};

float znm;
long ti=1;
point points[12];

//PLASMA
int ap=0,ep,fp,cp,dp;
int sinc[1800];

//SCROLL
int spr[5][5]={{10,30,30,30,10},
	       {30,120,70,50,30},
	       {30,70,70,50,30},
	       {30,50,50,50,30},
	       {10,30,30,30,10}};
char tex[5][64]={{"8 8 888  8  8 8 8   88  88 88   8  8   8    888 888 8 8 888     "},
		 {"8 8 8   8 8 8 8 8  8   8   8 8 8 8 8   8     8  8   8 8  8      "},
		 {" 8  88  888 888 8   8  8   88  8 8 8   8     8  88   8   8      "},
		 {" 8  8   8 8 8 8      8 8   8 8 8 8 8   8     8  8   8 8  8      "},
		 {" 8  888 8 8 8 8 8  88   88 8 8  8  888 888   8  888 8 8  8      "}};
unsigned char vscr[35][384];
int scl[350];
int es,fs;

PreScroll(void)
{
unsigned char  r=0,g=0,b=0;
for(short i=0;i<256;i++)
SetPal(i,0,0,0);
for(i=0;i<42;i++)
{
SetPal(i,r,g,b);
r++;
}
for(i=42;i<84;i++)
{
SetPal(i,r,g,b);
g++;
}
for (i=84;i<126;i++)
{
SetPal(i,r,g,b);
b++;
}

for(int a=0;a<64;a++)
{
for(int b=0;b<5;b++)
{
if(tex[b][a]=='8')
{
for(int c=0;c<5;c++)
{
for(int d=0;d<5;d++)
{
vscr[b*5+d+1][a*5+c]=spr[d][c];
}
}
}
}
}

for(int j=0;j<350;j++)
scl[j]=j;

}

void Scroll(void)
{
for(es=0;es<128;es++)
{
if(scl[es]<1)
scl[es]=350;
scl[es]--;
for(fs=0;fs<128;fs++)
{
image[1+(fs << 7)]=60;
image[126+(fs << 7)]=60;
image[fs]=60;
image[fs+16236]=60;
}

for(fs=0;fs<30;fs++)
image[es+((50+fs) << 7)]=vscr[30-fs][350-scl[es]];
}
}



PrePlasma(void)
{
for(int a=0;a<1800;a++)
sinc[a]=(sin((3.1416*a)/180)*1024);

unsigned char  r=0,g=0,b=0;
short i;
for(i=0;i<256;i++)
SetPal(i,0,0,0);
for(i=0;i<42;i++)
{
SetPal(i,r,g,b);
r++;
}
for(i=42;i<84;i++)
{
SetPal(i,r,g,b);
g++;
}
for (i=84;i<126;i++)
{
SetPal(i,r,g,b);
b++;
}
for (i=126;i<168;i++)
{
SetPal(i,r,g,b);
r--;
}
for (i=168;i<210;i++)
{
SetPal(i,r,g,b);
g--;
}
for (i=210;i<252;i++)
{
SetPal(i,r,g,b);
b--;
}
}

void Plasma(void)
{
ap++;
if(ap>720) ap=0;
for(cp=0;cp<128;cp++)
{
ep=75+((sinc[(cp << 1)+(ap >> 1)]+sinc[cp+(ap << 1)]+(sinc[(cp >> 1)+ap] << 1)) >> 6);
for(dp=0;dp<128;dp++)
{
fp=75+(((sinc[dp+(ap << 1)] << 1)+sinc[(dp << 1)+(ap >> 1)]+(sinc[dp+ap] << 1)) >> 5);
image[cp+128*dp]=((ep*fp) >> 5);
}
}
}



main()
{

Timer w;
DispInfo();
SetVGA();
SetVirtual();
SavePal();
PrePlasma();
//PreScroll();
w.reset();
w.start();

do
{
Plasma();
//Scroll();

ti++;
if(kbhit())
key=getch();
ax=ax+0.01;
ay=ay+0.009;
az=az+0.01;
mr[0][0] = cos(az)*cos(ay);
mr[1][0] = sin(az)*cos(ay);
mr[2][0] = -sin(ay);
mr[0][1] = cos(az)*sin(ay)*sin(ax)-sin(az)*cos(ax);
mr[1][1] = sin(az)*sin(ay)*sin(ax)+cos(ax)*cos(az);
mr[2][1] = sin(ax)*cos(ay);
mr[0][2] = cos(az)*sin(ay)*cos(ax)+sin(az)*sin(ax);
mr[1][2] = sin(az)*sin(ay)*cos(ax)-cos(az)*sin(ax);
mr[2][2] = cos(ax)*cos(ay);

for(int n=0;n<8;n++)
{
lxn[n]=lx[n]*mr[0][0]+ly[n]*mr[1][0]+lz[n]*mr[2][0];
lyn[n]=lx[n]*mr[0][1]+ly[n]*mr[1][1]+lz[n]*mr[2][1];
lzn[n]=lx[n]*mr[0][2]+ly[n]*mr[1][2]+lz[n]*mr[2][2]+5;
xd[n]=(320/2)+(320*lxn[n]*c)/(2*lzn[n]);
yd[n]=(200/2)+(200*lyn[n]*c)/(2*lzn[n]);
}

Cls(vaddr,0);
int facev=0;
for(int m=0;m<12;m++)
{
znm=(xd[face[m][1]]-xd[face[m][0]])*(yd[face[m][0]]-yd[face[m][2]])-(yd[face[m][1]]-yd[face[m][0]])*(xd[face[m][0]]-xd[face[m][2]]);
//znm=2; only zsorting
if(znm>0)
{
zface[m]=lzn[face[m][0]]+lzn[face[m][1]]+lzn[face[m][2]];
tri[facev]=m;
facev++;
}
}
QuickSort(0,facev-1);

for(int mb=0;mb<facev;mb++)
{
points[0].x = xd[face[tri[mb]][0]];
points[0].y = yd[face[tri[mb]][0]];
points[0].u = faceut[tri[mb]][0];
points[0].v = facevt[tri[mb]][0];
points[1].x = xd[face[tri[mb]][1]];
points[1].y = yd[face[tri[mb]][1]];
points[1].u = faceut[tri[mb]][1];
points[1].v = facevt[tri[mb]][1];
points[2].x = xd[face[tri[mb]][2]];
points[2].y = yd[face[tri[mb]][2]];
points[2].u = faceut[tri[mb]][2];
points[2].v = facevt[tri[mb]][2];

FillPoly(points,3);
}
//WaitRetrace();
//getch();

Flip(vaddr,vga);
}
while(key!=27);
RestorePal();
w.stop();
printf("*** FPS REPORT ***\n");
printf("secondes coules: %f\n",w.time());
printf("frames affiches: %d\n",ti);
printf("frame/seconde: %f\n",ti/w.time());
getch();
FreeVirtual();
}
