#include <iostream.h>
#include <conio.h>
#include <grafx2.cpp>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <timer.cpp>

unsigned char far sprite[65535];
unsigned char trance;

int Readpcx (char *name, char *image)
{
   FILE *dataFile = fopen (name, "rb");
   unsigned char color, r, g, b, counter, length;
   unsigned int x, y;

   dataFile = fopen (name, "rb");
   fseek (dataFile, -768, SEEK_END);
   for (x=0; x<256; x++)
     {
     r = fgetc (dataFile); r = r>>2;
     g = fgetc (dataFile); g = g>>2;
     b = fgetc (dataFile); b = b>>2;
     if(r==63 && b==63 && g==0)
     trance=x;
     SetPal (x, r, g, b);
     }

   x=0; y=0;
   fseek (dataFile, 128, SEEK_SET);
   while (y <= 255)
      {
      color = fgetc (dataFile);
      if (color < 192)			// uncompressed?
	 {
	 if (x > 255)
	   {
	   x=0; y++;
	   }
	 x++;
	 image[x+y*256]=color;
	 }
      else				// must be compressed
	 {
	 length = color-192;
	 color = fgetc (dataFile);
	 for (counter=0; counter<length; counter++)
	    {
	    if (x > 255)
	      {
	      x=0;
	      y++;
	      }
	    x++;
	    image[x+y*256]=color;
	    }
	 }
      }

   fclose (dataFile);
   //getch();
   return 0;
}

void Sprite(int x,int y,int xs, int ys,float rx, float ry,word where)
{
unsigned char far *screen = (char far*) MK_FP(where, 0);
int xn,yn;
int an,bn;
int rn,tn;
xn=xs*rx;
yn=ys*ry;
if(xn<2) xn=2;
if(yn<2) yn=2;
an=((float)(ys << 8))/yn;
bn=((float)(xs << 8))/xn;
rn=x-(xn >> 1);
tn=y-(yn >> 1);
for(int ut=1;ut<xn;ut++)
  {
  for(int vt=1;vt<yn;vt++)
    if(sprite[((ut*bn) >> 8)+((((vt*an) >> 8)+128) << 8)]!=trance)
    //if(ut+rn>0 && ut+rn<320)
    //if((vt+tn)>0 && (vt+tn)<200)
    screen[(ut+rn)+(vt+tn)*320]=sprite[((ut*bn) >> 8)+((((vt*an) >> 8)+128) << 8)];
  }
}

void Shade(int x,int y,int xs, int ys,float rx, float ry,word where)
{
unsigned char far *screen = (char far*) MK_FP(where, 0);
int xn,yn;
int an,bn;
int rn,tn;
xn=xs*rx;
yn=ys*ry;
if(xn<2) xn=2;
if(yn<2) yn=2;
an=((float)(ys << 8))/yn;
bn=((float)(xs << 8))/xn;
rn=x-(xn >> 1);
tn=y-(yn >> 1);
for(int ut=1;ut<xn;ut++)
  {
  for(int vt=1;vt<yn;vt++)
    if(sprite[((ut*bn) >> 8)+((((vt*an) >> 8)+128) << 8)]!=trance)
    //if(ut+rn>0 && ut+rn<320)
    //if((vt+tn)>0 && (vt+tn)<200)
    screen[(ut+rn)+(vt+tn)*320]=0;
  }
}

main()
{
SetVGA();
SetVirtual();
printf("Little demo coded by josh83");
getch();

Readpcx("demo2.pcx",sprite);
Timer w;
w.reset();

int xnew,ynew,xnew2,ynew2;
int difx,u,ustep;
int t=0,t2;


unsigned char far *dest = (char far*) MK_FP(vaddr, 0);

w.start();
int e,f;
int xs,ys,col;

do
{

t+=3;

Cls(vaddr,0);

for(int z=1;z<91;z++)
{

u=0;
difx=2*z+10;
ustep=(160 << 7)/difx;

  for(int x=0;x<160;x++)
  {

  xnew=(u >> 7)-((int)(u >> 14) << 7);
  ynew=(7000/z+t)-(((int)(7000/z+t) >> 7) << 7);
  xnew2=(u >> 9)-((int)(u >> 16) << 7);
  ynew2=(2048/z+(t >> 5))-(((int)(2048/z+(t >> 5)) >> 7) << 7);


  dest[160+x+(90-z)*320]=sprite[(256-(xnew2))+((ynew2) << 8)];
  dest[160-x+(90-z)*320]=sprite[(129+(xnew2))+((ynew2) << 8)];
  dest[160+x+(91+z)*320]=sprite[(128-xnew)+(ynew << 8)];
  dest[160-x+(91+z)*320]=sprite[(1+xnew)+(ynew << 8)];

  u+=ustep;

  }

}

for(int b=0;b<200;b+=10)
{
e=110+20*cos((b+t)*0.01)+15*sin((4*b+t)*0.01);
f=160+50*sin((2*b+t)*0.01)+25*cos((2*b+t)*0.01);
Sprite(f,e,127,127,0.1,0.1,vaddr);
Shade(f,(e >> 2)+135,127,127,0.1,0.04,vaddr);
}

for(int d=0;d<320;d++)
{

t2=((t/9)+d)-(((int)(((t/9)+d) >> 10)) << 10);
ys=(int)(t2 >> 7);
xs=t2-(ys << 7);

for(int c=0;c<15;c++)
{
//if(xs>0 && xs<128)
//if(ys*15+c+2>0 && ys*15+c+2<128)
dest[d+(c+184)*320]=sprite[(xs+129)+((ys*16+128+c) << 8)];
}
}

//WaitRetrace();
Flip(vaddr,vga);
}
while(!kbhit());
w.stop();
getch();
SetPal(7,63,63,63);
printf("\r%f FPS",t/(w.time()*3));
getch();
FreeVirtual();
}
