#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

int main(void)
{

int gdriver = DETECT, gmode, errorcode;
int midx, midy, size;

errorcode = registerbgifont(small_font);
if (errorcode < 0) { /* an error occured */
printf("Graphics error: %s\n",
grapherrormsg(errorcode));
printf("Press any key to halt:");
getch();
exit(1); /* terminate with an error code */
}

/* initialize graphics and local variables */
initgraph(&gdriver, &gmode, "");

/* read result of initialization */
errorcode = graphresult();

if (errorcode != grOk) { /* an error occured */
printf("Graphics error: %s\n",
grapherrormsg(errorcode));
printf("Press any key to halt:");
getch();
exit(1); /* terminate with an error code */
}

midx = getmaxx() / 2;
midy = getmaxy() / 2;
size = 4;
settextjustify(CENTER_TEXT, CENTER_TEXT);
settextstyle(SMALL_FONT, HORIZ_DIR, size);
outtextxy(midx, midy, "SMALL");


getch();

/*clean up*/
closegraph();
return 0;
}