/* mel.c*/

# include<stdio.h>
# include<stdlib.h>
# include<string.h>
# include<time.h>

/* definition de type structure*/

typedef struct cell {
char mel[25];           /* E-Mail*/
int tab[7];         /* tableau des numeros joues */
int tab2[7];            /* tableau des numros tires */
struct cell* suiv;      /* cellule suivante */
} cellule;

/*prototype des fonctions*/

void joue(cellule **t, char m[25], int g[7]);
void tirage(int g2[7]);
void detruit(cellule *t);
void comparaison (cellule *t, int g[7], int g2[7],int *l);

/*programme principal:menu*/

main()
{
char choix;             /* Choix dans le menu */
cellule *tete=NULL;     /* tete de liste chainee */
char m[25];             /* E mail saisi */
int g[7];           /* tableau des numeros remplis par les joueurs */
int g2[7];          /* tableau des numeros tires au sort */
int i;
int n;
int l;
do {
printf("\n\nJouer.........(1)\n");
printf("Voir les numeros gagnants.....(2)\n");
printf("Voir les resultats.....(3)\n");
printf("Quitter...........(0)\n\n");
printf("Votre choix ?");
scanf("%d",&choix);
switch (choix) {

case 1: { /*saisir*/
	printf("\nSaisir le nouvel Email :");
	scanf("%s",m);
	for (int i=0; i < 7; i++) {
	printf("\nSaisir un numero compris entre 1 et 49(%d):",i);
	scanf("%d",&g[i]);
	    }
	joue(&tete,m,g);

    break;
	}

case 2: { /* Tirage au sort*/
	printf("\n");
	tirage(g2);
	;
    break;
	}
case 3: { /* recherche des joueurs gagnants*/
    printf("\n");
    comparaison(tete,g,g2,&l);


    break;
}

case 0: { /* fin*/
	printf("\nBye Bye!\n\n");
    break;
    }
default: printf("\nErreur\n");
}
} while (choix!=0);
detruit(tete);          /* nettoyage*/
}

/* fonction d'ajout de joueur dans la liste chainee*/

void joue(cellule **t, char m[25], int g[7])
{
int i;
cellule *nouv;                          /* pointeur de nouvelle cellule*/
nouv=(cellule*)malloc(sizeof(cellule)); /* allocation dynamique d'une cellule*/
strcpy(nouv->mel, m);                   /* initialisation cellule-mail*/
for (i=0; i<=6; i++){
nouv->tab[i]= g[i];                     /* initialisation de la grille de jeu*/
}
nouv->suiv=*t;                          /* initialisation pointeur cellule suivante*/
*t=nouv;                            /* reinitialisation tete de liste sur nouvelle cellule*/
}



/* fonction de tirage de tous les numeros */

void tirage(int g2[7])
{
printf ("nbre aleatoire:");
for (int i=0;i<=6;i++)
{
g2[i]=1+random(49);
printf ("%d ",g2[i]);
}/* affichage numeros tires*/
}

/* fonction de comparaison des grilles des joueurs avec les numeros gagnants*/
void comparaison (cellule *t , int g[7] ,int g2[7],int *l)
{
char m[25];
cellule *cour=t;

while(cour!=NULL)
{
l=0;
for (int i=0;i<7;i++)
{
printf("%d: g1:%d g2:%d\n",i,g[i],g2[i]);
if (g[i]==g2[i])
l++;   //{l=l++;}
}
printf("Nom:%s\n",cour->mel,m);
printf("Nombre de numros gagnant:%d\n",l);
cour=cour->suiv;
l=0;
}
}

/* Fonction de destruction de la liste chainee*/

void detruit(cellule *t)
{
    cellule *cour=t; /*pointeur de cellule courante*/
    cellule *sauv;/* pointeur de cellule a detruire*/
    while (cour) {
    sauv=cour;
    cour=cour->suiv;
    free(sauv);
}
}
