#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <graphics.h>

/* Nomes dos estilos de texto aceitos */
char *nome[] = { "DEFAULT font",  "TRIPLEX font", 
                  "SMALL font",    "SANS SERIF_font", 
                  "GOTHIC_font",   "SCRIPT font",
                  "SIMPLEX font",  "TRIPLEX SCRIPT font",
                  "COMPLEX font",  "EUROPEAN font",
                  "BOLD font"};

int main(void)
{
   /* Solicitacao de auto-detecao e declaracao de variaveis locais*/
   int gdriver = DETECT, gmodo, coderro;
   int midx, midy, estilo, tam = 1;

   /* Inicializacao do modo grafico */
   initgraph(&gdriver, &gmodo, "");

   /* Leitura do resultado do processo de inicializacao */
   coderro = graphresult();
   if (coderro != grOk)  /* Ocorrencia de erro */
   {
      printf("Erro: %s\n", grapherrormsg(coderro));
      printf("Pressione qualquer tecla para sair:");
      getch();
      exit(1); /* Finalizacao com erro */
   }

   midx = getmaxx()/2;
   midy = getmaxy()/2;

   settextjustify(CENTER_TEXT, CENTER_TEXT);

   /* Laco para alternancia de estilos de texto */
   for (estilo=DEFAULT_FONT; estilo<=BOLD_FONT; estilo++)
   {
      cleardevice();
      if (estilo == TRIPLEX_FONT)
	 tam = 4;

      /* Selecao do estilo de texto */
      settextstyle(estilo, HORIZ_DIR,tam);

      /* Apresentacao de mensagem */
      outtextxy(midx, midy, nome[estilo]);
      getch();
   }

   closegraph();
   return 0;
}
