#include <graphics.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

/* Armazenamento de nomes de estilos de linha aceitos */
char *lnome[] = {"SOLID_LINE","DOTTED_LINE","CENTER_LINE","DASHED_LINE",
   "USERBIT_LINE"};

/* Armazenamento de nomes de USERBIT_LINES */
char *lnome1[] = {"USERBIT_LINE1","USERBIT_LINE2","USERBIT_LINE3",
"USERBIT_LINE4","USERBIT_LINE5"};

int main(void)
{
   /* Solicitacao de auto-detecao e declaracao de variaveis locais*/
   int gdriver = DETECT, gmodo, coderro;

   int i, estilo, midx, midy, padrao;
   char estilostr[40], estilostr1[40];

   /* Inicializao do modo grfico */
   initgraph(&gdriver, &gmodo, "");

   /* Leitura do resultado do processo de inicializacao */
   coderro = graphresult();
   if (coderro != grOk)  /* Ocorrencia de erro */
   {
      printf("Erro: %s\n", grapherrormsg(coderro));
      printf("Pressione qualquer tecla para sair:");
      getch();
      exit(1); /* Finalizacao com erro */
   }

   midx = getmaxx() / 2;
   midy = getmaxy() / 2;

	for(i=1;i<=15;i++){
		setcolor(i);
		line(5,5,20*i,20*i);
		delay(500);
		cleardevice();
	}
	for(i=1;i<=15;i++){
		setcolor(i);
		rectangle(5,5,15*i,15*i);
		delay(500);
		cleardevice();
	}
	for(i=1;i<=15;i++){
		setcolor(i);
		setlinestyle(estilo, padrao, 1);
		ellipse(300,200,i,25*i,15*i,8*i);
		delay(300);
		cleardevice();
	}
	for(i=1;i<=15;i++){
		setcolor(i);
		setfillstyle(SOLID_FILL, 16-i);
		bar3d(200,200,400,400,50,50);
		outtextxy(280,300, "TESTE");
		delay(500);
		cleardevice();
	}
   /* Definicao de padrao de linha pelo usuario */
   padrao = 0x8888;
   for (estilo=SOLID_LINE; estilo<=USERBIT_LINE; estilo++)

   {  /* Selecao de estilo de linha */
      setlinestyle(estilo, padrao, 1);

      /* Conversao do estilo em string */
      strcpy(estilostr, lnome[estilo]);

      /* Alteracao da cor do tracado */
      setcolor(3*estilo);

      /* Tracado de linha */
      line(0, 0, midx-10, midy);

      /* Apresentacao de mensagem */
      outtextxy(midx, midy, estilostr);

      /* Retencao do tracado na tela */
      delay(500);
      cleardevice();
   }
   estilo=SOLID_LINE;
   while(estilo<=USERBIT_LINE)
   {  /* Selecao de estilo de linha */
      setlinestyle(estilo, padrao, 1);

      /* Conversao do estilo em string */
      strcpy(estilostr, lnome[estilo]);

      /* Alteracao da cor do tracado */
      setcolor(3*(estilo+1));

      /* Tracado de linha */
      line(midx-100, midy-100+20*estilo,midx-40, midy-100+20*estilo);

      /* Apresentacao de mensagem */
      outtextxy(midx, midy-105+20*estilo, estilostr);
      estilo++;
      delay(100);
   }
   delay(2000);
   cleardevice();
   padrao = 0xFFFF;
   for (i=1; i<=5; i++)
   {  /* Selecao de estilo de linha */
      if(i<3) setlinestyle(USERBIT_LINE, padrao<<3*i,1);
      else setlinestyle(USERBIT_LINE, padrao<<3*i,3);
      /* Conversao do estilo em string */
      strcpy(estilostr1, lnome1[i-1]);

      /* Alteracao da cor do tracado */
      setcolor(2*i+4);

      /* Tracado de linha */
      line(midx-240, midy+20*(i-5),midx-30, midy+20*(i-5));

      /* Apresentacao de mensagem */
      outtextxy(midx, midy-103+20*i, estilostr1);
      delay(100);
   }
   getch();
   closegraph(); /* Encerramento do modo grafico */
   return 0;
}