/* Atrelar ao programa relogio.c */

#ifndef GR_INIT
#define GR_INIT
#include <stdio.h>
#include <graphics.h>
#include <stdlib.h>

void ABORT(char*);
void inicializa_dr_e_ft();

void ABORT(char *msg)
{
   int erro = graphresult();
   printf("%s: %s\n", msg, grapherrormsg(erro));
   exit(erro);
}

void inicializa_dr_e_ft()
{
int driver, modo, erro;
   if (registerfarbgidriver(CGA_driver_far) < 0)
      ABORT("CGA");
   if (registerfarbgidriver(EGAVGA_driver_far) < 0)
      ABORT("EGA\VGA");
   if (registerfarbgidriver(Herc_driver_far) < 0)
      ABORT("Herc");
   if (registerfarbgidriver(ATT_driver_far) < 0)
      ABORT("AT&T");
   if (registerfarbgidriver(PC3270_driver_far) < 0)
      ABORT("PC 3270");
   if (registerfarbgifont(gothic_font_far) < 0)
      ABORT("Gothic");
   if (registerfarbgifont(sansserif_font_far) < 0)
      ABORT("SansSerif");
   if (registerfarbgifont(small_font_far) < 0)
      ABORT("Small");
   //if (registerfarbgifont(triplex_font_far) < 0)
   //   ABORT("Triplex");
   driver = DETECT;
   initgraph(&driver, &modo, "c:\\tc\\BGI");
   erro = graphresult();
   if (erro != grOk)
   {
      printf("Erro: %s\n", grapherrormsg(erro));
      exit(erro);
   }
}

#endif GR_INIT