#include <graphics.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

/* Armazenamento de nomes de preenchimento de linha aceitos */
char *fnome[] = { "EMPTY_FILL", "SOLID_FILL", "LINE_FILL",
"LTSLASH_FILL", "SLASH_FILL", "BKSLASH_FILL", "LTBKSLASH_FILL",
"HATCH_FILL", "XHATCH_FILL", "INTERLEAVE_FILL", "WIDE_DOT_FILL",
"CLOSE_DOT_FILL", "USER_FILL" };

char *fnome1[] = { "EMPTY_FILL P25", "SOLID_FILL P25", "LINE_FILL P25",
"LTSLASH_FILL P25", "SLASH_FILL P25", "BKSLASH_FILL P25", "LTBKSLASH_FILL P25",
"HATCH_FILL P25", "XHATCH_FILL P25", "INTERLEAVE_FILL P25", "WIDE_DOT_FILL P25",
"CLOSE_DOT_FILL P25", "USER_FILL P25" };

int main(void)
{
   /* Solicitacao de auto-detecao e declaracao de variaveis locais*/
   int gdriver = DETECT, gmodo, coderro;

   int i, j, midx, midy;


   /* Inicializao do modo grfico */
   initgraph(&gdriver, &gmodo, "");

   /* Leitura do resultado do processo de inicializacao */
   coderro = graphresult();
   if (coderro != grOk)  /* Ocorrencia de erro */
   {
      printf("Erro: %s\n", grapherrormsg(coderro));
      printf("Pressione qualquer tecla para sair:");
      getch();
      exit(1); /* Finalizacao com erro */
   }

   midx = getmaxx() / 2;
   midy = getmaxy() / 2;

   /* Definicao do padrao de preenchimento */
   for (j = 0; j <= 2; j++) {
	for (i = 0; i <= 15; i++) {
	setcolor(15-i);
	setfillstyle(i, i);
	bar(midx-200+3*i,midy-150+3*i,midx+200-3*i,midy+150-3*i);
	/* Retencao do tracado na tela */
	delay(50);
	sound (100+10*i);
	cleardevice();/* Apagamento da tela */
	}
	for (i = 15; i >= 0; i--) {
	setcolor(i);
	setfillstyle(i, 15-i);
	bar(midx-200+3*i,midy-150+3*i,midx+200-3*i,midy+150-3*i);
	/* Retencao do tracado na tela */
	delay(50);
	sound (300+15*i);
	cleardevice();/* Apagamento da tela */
	}
   }
   nosound();
   getch();
   closegraph();/* Encerramento do modo grafico */

   return 0;
}