#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

int main(void)
{
   int gdriver = DETECT, gmodo, coderro;
   int i, maxx, maxy;
   int poligono[4]; /* Array do poligono */

   initgraph(&gdriver, &gmodo, "");
   coderro = graphresult();
   if (coderro != grOk) {  
      printf("Erro: %s\n",grapherrormsg(coderro));
      printf("Pressione qualquer tecla para encerrar!");
      getch();
      exit(1);
   }

   maxx = getmaxx();
   maxy = getmaxy();

   poligono[0] = 100; /* Primeiro vertice */
   poligono[1] = maxy/2;
   poligono[2] = maxx-200; /* Segundo vertice */
   poligono[3] = 200;
   poligono[4] = maxx/2;  /* Terceiro vertice */
   poligono[5] = maxy/3;
   poligono[6] = maxx/4; /* Quarto vertice, preenchimento 
				      automatico */
   poligono[7] = maxy/3;  /* Fechamento do poligono */

   /* Laco para configuracao de padroes de preenchimento */
   for (i=EMPTY_FILL; i<USER_FILL; i++) {
      setcolor(i);
      setfillstyle(i, i);

      fillpoly(4, poligono); /* Tracado de um poligono preenchido */

      delay(1000);
      cleardevice();
   }
   getch();
   closegraph();
   return 0;
}
