#include <graphics.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

/* Armazenamento de nomes de USERBIT_LINES */
char *lnome[] = {"USERBIT_LINE1","USERBIT_LINE2","USERBIT_LINE3",
"USERBIT_LINE4","USERBIT_LINE5"};

int main(void)
{
   /* Solicitacao de auto-detecao e declaracao de variaveis locais*/
   int gdriver = DETECT, gmodo, coderro;

   int i, midx, midy, padrao;
   char estilostr[40];

   /* Inicializao do modo grfico */
   initgraph(&gdriver, &gmodo, "");

   /* Leitura do resultado do processo de inicializacao */
   coderro = graphresult();
   if (coderro != grOk)  /* Ocorrencia de erro */
   {
      printf("Erro: %s\n", grapherrormsg(coderro));
      printf("Pressione qualquer tecla para sair:");
      getch();
      exit(1); /* Finalizacao com erro */
   }

   midx = getmaxx() / 2;
   midy = getmaxy() / 2;


   padrao = 0xFFFF;
   for (i=1; i<=5; i++)
   {  /* Selecao de estilo de linha */
      setlinestyle(USERBIT_LINE, padrao<<3*i, 1);

      /* Conversao do estilo em string */
      strcpy(estilostr, lnome[i-1]);

      /* Alteracao da cor do tracado */
      setcolor(2*i+4);

      /* Tracado de linha */
      line(midx-240, midy+20*(i-5),midx-30, midy+20*(i-5));

      /* Apresentacao de mensagem */
      outtextxy(midx, midy-103+20*i, estilostr);
   }
   getch();
   closegraph(); /* Encerramento do modo grafico */
   return 0;
}