Unit Fonty;

Interface

Uses Graph,FontDat;


Procedure WriteZnak(X,Y : Integer;Zn : Char);
Procedure RetezS(S : String;Color : Word);
Procedure Znak(Zn : Char);
Procedure ZnakS(Zn : Char;Color : Word);
Procedure WriteRetez(X,Y : Integer;S : String);
Procedure WriteRetezS(X,Y : Integer;S : String;Color : Word);
{Procedure StartFont;}
Procedure BezDo(Xf,Yf : Integer);
Procedure Retez(S : String);

Implementation

Var
  X,Y : Integer;

Procedure BezDo(Xf,Yf : Integer);
Begin
  X := Xf;
  Y := Yf;
end;

Procedure Znak(Zn : Char);
Var
  PB,PPB : Byte;
  PA : A;
  I,J : Integer;
Begin
  PA := Pole[Ord(Zn)];
  For I := 1 to 16 do
  Begin
    PB := PA[I];
    For J := 8 downto 1 do
    Begin
      PPB := PB div 2;
      If (PB-(PPB*2)) > 0 then
         PutPixel(X+J,Y+I,GetColor);
      PB := PPB;
    end;
  end;
  X := X+8;
end;

Procedure ZnakS(Zn : Char;Color : Word);
Var
  PB,PPB : Byte;
  PA : A;
  I,J : Integer;
Begin
  PA := Pole[Ord(Zn)];
  For I := 1 to 16 do
  Begin
    PB := PA[I];
    For J := 8 downto 1 do
    Begin
      PPB := PB div 2;
      If (PB-(PPB*2)) > 0 then
         PutPixel(X+J,Y+I,GetColor)
      else
         PutPixel(X+J,Y+I,Color);
      PB := PPB;
    end;
  end;
  X := X+8;
end;

Procedure WriteZnak(X,Y : Integer;Zn : Char);
Var
  PB,PPB : Byte;
  PA : A;
  I,J : Integer;
Begin
  PA := Pole[Ord(Zn)];
  For I := 1 to 16 do
  Begin
    PB := PA[I];
    For J := 8 downto 1 do
    Begin
      PPB := PB div 2;
      If (PB-(PPB*2)) > 0 then
         PutPixel(X+J,Y+I,GetColor);
      PB := PPB;
    end;
  end;
end;

Procedure WriteZnakS(X,Y : Integer;Zn : Char;Barva : Word);
Var
  PB,PPB : Byte;
  PA : A;
  I,J : Integer;
Begin
  PA := Pole[Ord(Zn)];
  For I := 1 to 16 do
  Begin
    PB := PA[I];
    For J := 8 downto 1 do
    Begin
      PPB := PB div 2;
      If (PB-(PPB*2)) > 0 then
         PutPixel(X+J,Y+I,GetColor)
      else
         PutPixel(X+J,Y+I,Barva);
      PB := PPB;
    end;
  end;
end;


Procedure WriteRetez(X,Y : Integer;S : String);
Var
  I : Integer;
Begin
  X := X-8;
  For I := 1 to Length(S) do
    WriteZnak(X+((I*8)-1),Y,S[I]);
end;

Procedure WriteRetezS(X,Y : Integer;S : String;Color : Word);
Var
  I : Integer;
Begin
  X := X-8;
  For I := 1 to Length(S) do
    WriteZnakS(X+((I*8)-1),Y,S[I],Color);
end;


Procedure Retez(S : String);
Var
  I : Integer;
Begin
  X := X -8;
  For I := 1 to Length(S) do
    WriteZnak(X+((I*8)-1),Y,S[I]);
end;

Procedure RetezS(S : String;Color : Word);
Var
  I : Integer;
Begin
  X := X -8;
  For I := 1 to Length(S) do
    WriteZnakS(X+((I*8)-1),Y,S[I],Color);
end;


end.