// PHONG SHADING POLYGON LIBRARY CODED BY JOSH83

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <limits.h>

typedef struct
    {
     int x,y;
     long nx,ny,nz;
    } point;


const int INFINI = INT_MIN;

int startx[200];
int endx[200];

long startnx[200];
long endnx[200];
long startny[200];
long endny[200];
long startnz[200];
long endnz[200];

int lux=0;
int luy=0;
int luz=10;
float lun=sqrt(lux*lux+luy*luy+luz*luz);

int miny,maxy;


/*
void HlineG4 (int x1, char firstcolor, int x2, char lastcolor, int y)
{
int length;
int numcolors;
int colorvalue;
int step;
int x;
 if(x2<x1)
  {
    x=x1;
    x1=x2;
    x2=x;

    x=firstcolor;
    firstcolor=lastcolor;
    lastcolor=x;
  }
 length = x2 - x1 + 1;
 if (length > 0)
 {
  numcolors = lastcolor - firstcolor + 1;

  colorvalue = firstcolor << 8;
  step = ((long)numcolors << 8) / (long)length;


  for (x = x1; x <= x2; x++)
    {
     Putpixel(x,y,colorvalue >> 8,vga);
     // Draw the pixel and move to the next location in memory

     colorvalue += step;
    }
 }
}

void HlineG3 (int x1, int firstcolor, int x2, int lastcolor, int y)
{
int length;
int numcolors;
int colorvalue;
int step;
int x;
unsigned char *dest;   // Ptr to the screen

 length = x2 - x1 + 1;
 if (length > 0)
 {
  numcolors = lastcolor - firstcolor + 1;

  colorvalue = firstcolor << 8;
  step = ((long)numcolors << 8) / (long)length;

  dest = virscr + y * 320 + x1;
  // Make a pointer to the first pixel

  for (x = x1; x <= x2; x++)
    {
     *dest++ = colorvalue >> 8;
     // Draw the pixel and move to the next location in memory

     colorvalue += step;
    }
 }
}
*/
void HlineG(int x1, long nx1, long ny1, long nz1,
	    int x2, long nx2, long ny2, long nz2, int y,word where)
{
unsigned char far *dest = (char far*) MK_FP(where, 0);
  long indice;
  long x,difx,pasx;
  long nx,difnx,pasnx;
  long ny,difny,pasny;
  long nz,difnz,pasnz;
  long couleur,ang;

  if(x2<x1)
  {
    x=x1; x1=x2; x2=x;
    x=nx1; nx1=nx2; nx2=x;
    x=ny1; ny1=ny2; ny2=x;
    x=nz1; nz1=nz2; nz2=x;
  }

  indice= y*320+x1;
  difx = x2-x1+1;
  difnx = nx2-nx1+1;
  difny = ny2-ny1+1;
  difnz = nz2-nz1+1;
  nx = nx1 << 8;
  ny = ny1 << 8;
  nz = nz1 << 8;
  pasnx = (difnx << 8)/difx;
  pasny = (difny << 8)/difx;
  pasnz = (difnz << 8)/difx;

  for(x=x1;x<=x2;x++)
  {
    ang = ((long)(nx*lux+ny*luy+nz*luz) << 8) / ((long)(lun*sqrt(nx*nx+ny*ny+nz*nz)));
    //angle = (nx*lux+ny*luy+nz*luz)/(lun*sqrt(nx*nx+ny*ny+nz*nz));
    //couleur = 64*1+16+64-(32+couleur*32);
    couleur= 32+(long)(60*ang >> 8);//+(long)((25*ang*ang) >> 16);
    dest[indice++]=couleur;
    //Putpixel(x,y,couleur,vaddr);
    nx += pasnx;
    ny += pasny;
    nz += pasnz;
  }
}


void PolyLine (int x1, int y1, long nx1, long ny1, long nz1,
	       int x2, int y2, long nx2, long ny2, long nz2)
{
 long tmp,y;
 long x,xs;
 long nx,nxs;
 long ny,nys;
 long nz,nzs;

 if (y2 != y1)
 {
   if (y2 < y1)
   {
    tmp = y1; y1 = y2; y2 = tmp;
    tmp = x1; x1 = x2; x2 = tmp;
    tmp = nx1; nx1 = nx2; nx2 = tmp;
    tmp = ny1; ny1 = ny2; ny2 = tmp;
    tmp = nz1; nz1 = nz2; nz2 = tmp;
   }

 x   = (long)x1 << 8;
 xs  = ((long)(x2 - x1) << 8) / ((long)(y2 - y1));
 nx  = (long)nx1 << 8;
 nxs = ((long)(nx2 - nx1) << 8) / ((long)(y2 - y1));
 ny  = (long)ny1 << 8;
 nys = ((long)(ny2 - ny1) << 8) / ((long)(y2 - y1));
 nz  = (long)nz1 << 8;
 nzs = ((long)(nz2 - nz1) << 8) / ((long)(y2 - y1));

 x += xs;
 nx += nxs;
 ny += nys;
 nz += nzs;
 y1++;

 for (y = y1; y <= y2; y++)
  {
   if ((y >= 0) & (y < 200))
       if (startx[y] == -16000)
      {
       startx[y] = x>>8;
       startnx[y] = nx >> 8;
       startny[y] = ny >> 8;
       startnz[y] = nz >> 8;
      }
    else
      {
       endx[y] = x>>8;
       endnx[y] = nx >> 8;
       endny[y] = ny >> 8;
       endnz[y] = nz >> 8;
      }
   x += xs;
   nx += nxs;
   ny += nys;
   nz += nzs;
  }
 }
}


void FillPoly (point *vertexlist, int numvertex)
{
int i;
point *curpt,*nextpt;

 curpt = vertexlist;
 nextpt = vertexlist + 1;

 for (i = 0; i < 200; i++)
  {
   startx[i] = -16000;
   endx[i] = -16000;
  }

 for (i = 1; i < numvertex; i++)
  {
   PolyLine (curpt->x, curpt->y, curpt->nx, curpt->ny, curpt->nz
   ,nextpt->x, nextpt->y, nextpt->nx, nextpt->ny, nextpt->nz );

   curpt += 1;
   nextpt += 1;
  }

  nextpt = vertexlist;

  PolyLine (curpt->x, curpt->y, curpt->nx, curpt->ny, curpt->nz
   ,nextpt->x, nextpt->y, nextpt->nx, nextpt->ny, nextpt->nz );


  for (i = 0; i < 200; i++)
    if (startx[i] != -16000)
    {
     if (endx[i] == -16000)
	 endx[i] = startx[i];
       //if(startx[i]<endx[i])
	 HlineG(startx[i],startnx[i],startny[i],startnz[i],endx[i],endnx[i],endny[i],endnz[i],i,vaddr);
	 //else
	 //HlineG(endx[i],endcol[i],startx[i],startcol[i],i);
    }
}
