/*********************************************
 * FLAT FILLING POLYGON ROUTINE BY JOSH83    *
 * 80% c++ and 20% asm for maximum speed     *
 *********************************************/


#include <dos.h>
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>


int startx[200];
int endx[200];

typedef struct
    {
     int x,y;
    } point;

const int INFINI =  -16000;
int miny,maxy;

void Hline (int x1, int x2, int y, byte col, word where)
{
  for(int i=x1;i<x2;i++)
  if(i>0 && i<320)
  if(y>0 && y<200)
  Putpixel(i,y,col,where);
}





void Hline2 (word x1, word x2, word y, byte col, word where)
{
  asm {
    mov     ax, [where]  // move segment of Where to AX
    mov     es, ax       // set ES to segment of Where
    mov     ax, [y]      // set AX to Y
    mov     di, ax       // set DI to Y
    shl     ax, 8        // shift AX left 8 places (multiply Y by 256)
    shl     di, 6        // shift DI left 6 places (multiply Y by 64)
    add     di, ax       // add AX to DI (Y*64 + Y*256 = Y*320)
    add     di, [x1]     // add the X1 offset to DI
    mov     al, [col]    // move Col to AL
    mov     ah, al       // move Col to AH (we want 2 copies for word moving)
    mov     cx, [x2]     // move X2 to CX
    sub     cx, [x1]     // move the change in X to CX
    shr     cx, 1        // divide change in X by 2 (for word moving)
    jnc     Start        // if we have an even number of moves, go to Start
    stosb                // otherwise, move one byte more
  }
  Start: asm {
    rep     stosw        // do it!
  }
}
/*
void InitSegment(point p1, point p2)
{
  point temp;
  long x,pas;
  int  y;

  if(p2.y!=p1.y)
  {
    if(p2.y<p1.y)
    {
      temp = p1;
      p1   = p2;
      p2   = temp;
    }

    x  = p1.x<<8;
    pas= ((p2.x-p2.x)<<8)/(p2.y-p1.y);

    x+=pas;
    p1.y++;

    if(p1.y<miny) miny=p1.y;
    if(p2.y>maxy) maxy=p2.y;

    for(y=p1.y;y<=p2.y;y++)
    {
      if((y>=0) && (y<200))
	if(startx[y]==INFINI)
	  startx[y]=x>>8;
	else
	  endx[y]=x>>8;
      x+=pas;
    }
  }
}

void FillPoly2(point *vertexlist, int numvertex,int color)
{
  int i;
  point *curpt,*nextpt;

  miny=200;
  maxy=0;

  curpt  = vertexlist;
  nextpt = vertexlist+1;

  for(i=1;i<numvertex;i++)
  {
    InitSegment(*curpt,*nextpt);
    curpt++;
    nextpt++;
  }

  nextpt = vertexlist;
  InitSegment(*curpt,*nextpt);

  if(miny<0) miny=0;
  if(maxy>=200) maxy=200-1;

  for(i=miny;i<=maxy;i++)
    {
     if(endx[i]==INFINI)
	endx[i]=startx[i];

      if(startx[i]<endx[i])
      Hline(startx[i],endx[i],i,color,vaddr);
      else
      Hline(endx[i],startx[i],i,color,vaddr);
      startx[i]=endx[i]=INFINI;
     }
}
*/
void PolyLine (int x1, int y1, int x2, int y2)
{
 int tmp,y;
 long x,m;
 if (y2 != y1)
 {
   if (y2 < y1)
   {
    tmp = y1;
    y1 = y2;
    y2 = tmp;

    tmp = x1;
    x1 = x2;
    x2 = tmp;
   }
 x = (long)x1<<8;
 m = ((long)(x2 - x1)<<8) / ((long)(y2 - y1));
 x += m;
 y1++;
 for (y = y1; y <= y2; y++)
  {
   if ((y >= 0) & (y < 200))
    if (startx[y] == -16000)
      startx[y] = x>>8;
    else
      endx[y] = x>>8;
   x += m;
   }
 }
}



void FillPoly (point *vertexlist, int numvertex,byte c,word where)
{
int i;
point *curpt,*nextpt;
 curpt = vertexlist;
 nextpt = vertexlist + 1;
 for (i = 0; i < 200; i++)
  {
   startx[i] = -16000;
   endx[i] = -16000;
  }
 for (i = 1; i < numvertex; i++)
  {
   PolyLine (curpt->x, curpt->y, nextpt->x, nextpt->y);
   curpt += 1;
   nextpt += 1;
  }
  nextpt = vertexlist;
  PolyLine (curpt->x, curpt->y, nextpt->x, nextpt->y);
  for (i = 0; i < 200; i++)
    if (startx[i] != -16000)
    {
     if (endx[i] == -16000)
	 endx[i] = startx[i];

    //Line(startx[i],i,endx[i],i,c,vga);

    if(startx[i]<endx[i])
    Hline(startx[i],endx[i],i,c,where);
    else
    Hline(endx[i],startx[i],i,c,where);
    }
}



