//3DS OBJET FLAT FILLING

#include <iostream.h>
#include <conio.h>
#include <grafx2.cpp>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <timer.cpp>
#include <string.h>
#include <flib1.cpp>

char key;
int coor[1000][3];
int face[1000][3];
int facecolor[1000];
unsigned int nbpt,test,nbf,ti,nbp;

int tri[1000];
int zface[1000];

void QuickSort(int deb, int fin)
{
  int   i=deb;
  int   j=fin;
  double milieu=256*zface[tri[(deb+fin)/2]];
  int   temp;

  while(i<=j)
  {
    while(256*zface[tri[i]]> milieu) i++;
    while(256*zface[tri[j]]< milieu) j--;

    if(i<=j)
    {
      temp=tri[i];
      tri[i]=tri[j];
      tri[j]=temp;
      i++; j--;
    }
  }

  if(i<fin) QuickSort(i,fin);
  if(deb<j) QuickSort(deb,j);
}



void LoadASC(char *nom)
{
  FILE  *fichier;
  char  chaine[200];
  char  *fin;
  int   i,j;
  char  temp[50];
  float x,y,z;
  int   a,b,c;
  int   decalage=0;

  nbpt=0;
  test=0;
  nbf=0;
  nbp=0;

  if ((fichier = fopen(nom,"rt"))==NULL)
  {
    perror("Impossible d'ouvrir le fichier en lecture");
    exit(-2);
  }

  do
  {
    // On lit le fichier contenant les informations sur l'objet
    fin=fgets(chaine,100,fichier);
    if (!strncmp(chaine,"Vertex",6))
    {
      if (strncmp(chaine,"Vertex list",11))
      {
	// Lecture des coordonnes d'un point
	i=0;

	while(chaine[i]!='X') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&x);

	while(chaine[i]!='Y') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&y);

	while(chaine[i]!='Z') i++;
	i+=2;
	while(chaine[i]==' ') i++;
	sscanf(chaine+i,"%f",&z);

	coor[nbp][0]=x/16;
	coor[nbp][1]=y/16;
	coor[nbp][2]=z/16;

	nbp++;
      }
    }

    else
    {
      if (!strncmp(chaine,"Face",4))
      {
	if (strncmp(chaine,"Face list",9))
	{
	  // Lecture d'une facette
	  i=j=0;
	  while(chaine[i]!='A') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][0]=atoi(temp)+decalage;

	  while(chaine[i]!='B') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][1]=atoi(temp)+decalage;

	  while(chaine[i]!='C') i++;
	  i+=2;
	  j=i;
	  while(chaine[j]!=' ') j++;
	  strncpy(temp,chaine+i,j-i);
	  temp[j-i]=0;
	  face[nbf][2]=atoi(temp)+decalage;

	  nbf++;
	  }
	}
      else
	if (!strncmp(chaine,"Named object",12))
	  decalage=nbp;
    }
  } while(fin!=NULL);


  fclose(fichier);
}

int lxn[500],lyn[500],lzn[500];
int xd[500],yd[500];
int xt,yt,zt;
int ax,ay,az,axnew,aynew,aznew;
int xsin,xcos,ysin,ycos,zsin,zcos;
int znm,facev;
point points[3];

main()
{
LoadASC("duck.asc");
printf("points:%d - faces:%d",nbp,nbf);
getch();
Timer w;
SetVirtual();
SetVGA();
w.reset();
ax=0;
ay=0;
az=0;

//CALC SIN COS TABLE

int sine[256];
int cose[256];

for(int i=0;i<256;i++)
{
sine[i]=(sin(i*0.02454))*128;
cose[i]=(cos(i*0.02454))*128;
}

for(i=0;i<nbf;i++)
  facecolor[i]=random(15)+1;


do
{

w.start();
ti++;
if(kbhit())
key=getch();

ax+=1;
ay+=1;
az+=1;

axnew=ax-(((int)(ax>>8)) << 8);
aynew=ay-(((int)(ay>>8)) << 8);
aznew=az-(((int)(az>>8)) << 8);

for(int n=0;n<nbp;n++)
{

xsin = sine[axnew];
xcos = cose[axnew];
ysin = sine[aynew];
ycos = cose[aynew];
zsin = sine[aznew];
zcos = cose[aznew];

yt     = ((coor[n][1] * xcos - coor[n][2] *  xsin) >> 7);
zt     = ((coor[n][1] * xsin + coor[n][2] *  xcos) >> 7);
xt     = ((coor[n][0] * ycos - zt * ysin) >> 7);
lzn[n] = ((coor[n][0] * ysin + zt * ycos) >> 7);
lxn[n] = ((xt * zcos - yt *  zsin) >> 7);
lyn[n] = ((xt * zsin + yt *  zcos) >> 7);

xd[n]=160+(lxn[n] << 7)/(lzn[n]+300);
yd[n]=100+(lyn[n] << 7)/(lzn[n]+300);
}

Cls(vaddr,0);

int facev=0;
for(int m=0;m<nbf;m++)
{
znm=(xd[face[m][1]]-xd[face[m][0]])*(yd[face[m][0]]-yd[face[m][2]])-(yd[face[m][1]]-yd[face[m][0]])*(xd[face[m][0]]-xd[face[m][2]]);
//znm=2; //only zsorting
if(znm>0)
{
zface[m]=lzn[face[m][0]]+lzn[face[m][1]]+lzn[face[m][2]];
tri[facev]=m;
facev++;
}
}
QuickSort(0,facev-1);


for(int mb=0;mb<facev;mb++)
{
points[0].x = xd[face[tri[mb]][0]];
points[0].y = yd[face[tri[mb]][0]];
points[1].x = xd[face[tri[mb]][1]];
points[1].y = yd[face[tri[mb]][1]];
points[2].x = xd[face[tri[mb]][2]];
points[2].y = yd[face[tri[mb]][2]];
FillPoly(points,3,facecolor[tri[mb]],vaddr);
}

Flip(vaddr,vga);

}
while(key!=27);
w.stop();
printf("*** FPS REPORT ***\n");
printf("secondes coules: %f\n",w.time());
printf("frames affiches: %d\n",ti);
printf("frame/seconde: %f\n",ti/w.time());
getch();
FreeVirtual();
}
