//BUMPMAPPING

#include <iostream.h>
#include <conio.h>
#include <grafx2.cpp>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <timer.cpp>

unsigned char far envmap[65535];
unsigned char far bumpmap[64000];
long cosp[360],sinp[360];


void Readpcx (char *name)
{
FILE *dataFile = fopen (name, "rb");
unsigned char color, counter, length;
unsigned int x=0, y=0;
dataFile = fopen (name, "rb");
fseek (dataFile, 128, SEEK_SET);

while (y <= 199)
  {
  color = fgetc (dataFile);
  if (color < 192)
    {
    if (x > 319) {x=0; y++;}
    x++;
    bumpmap[x+y*320]=color;
    }
  else
    {
    length = color-192;
    color = fgetc (dataFile);
    for (counter=0; counter<length; counter++)
      {
      if (x > 319) {x=0;y++;}
      x++;
      bumpmap[x+y*320]=color;
      }
    }
  }
fclose (dataFile);
}


void PrePal(void)
{
/*float r;
for(int i=32;i<224;i++)
{
SetPal(i,r,r,r);
r+=0.3 ;*/
float r=0,g=0,b=0;
short i;
for(i=32;i<256;i++)
SetPal(i,0,0,0);
//SetPal(0,0,0,20);
for(i=0;i<100;i++)
{
SetPal(i,r,0,0);
r+=0.5;
}
for(i=100;i<128;i++)
{
SetPal(i,r,g,b);
r+=0.5;
g+=2;
b+=2;
}
r=0,g=0,b=0;
for(i=128;i<228;i++)
{
SetPal(i,0,0,b);
b+=0.5;
}
for(i=228;i<256;i++)
{
SetPal(i,r,g,b);
b+=0.5;
g+=2;
r+=2;
}
}

void CalcTrigo(void)
{
for(int i=0;i<360;i++)
{
cosp[i] = (long)(cos(i*0.017453)*256);
sinp[i] = (long)(sin(i*0.017453)*256);
}
}

main()
{
int nxb, nyb, x, y ,lx,ly;
int offset, frame=0, a=0;
float nx,ny,nz;
int contrast=1,col=0;   //COULEUR: 0:rouge 1:bleu

Timer fps;
fps.reset();
SetVGA();
SavePal();
unsigned char far *dest = (char far*) MK_FP(vga, 0);
printf("BUMP MAPPING EFFECT CODED BY JOSH83");
getch();

Readpcx("bump1.pcx");
PrePal();
CalcTrigo();

//CALC ENVIRONNMENT MAP
for (y=0;y<256;y++)
  {
  for (x=0;x<256;x++)
    {
    nx=(x-128)/128.0;
    ny=(y-128)/128.0;
    nz=1-sqrt(nx*nx+ny*ny);
    if (nz<0) nz=0;
    envmap[x+(y*256)] = 127 * nz+ 128*col;
    }
  }

fps.start();

do
{
frame++;
a+=2;
if(a>359) a=0;
lx=280+((230*cosp[a]*sinp[a]) >> 16);
ly=230+((70*sinp[a]+10*cosp[a])  >> 8);

offset=0;
for (y=0;y<200;y++)
   {
   for (x=0;x<320;x++)
     {
     nxb=(bumpmap[offset+1]-bumpmap[offset-1])* contrast-(x-lx);
     nyb=(bumpmap[offset+1]-bumpmap[offset-1])* contrast-(y-ly);

     if (nxb>255 || nxb<0) nxb=255;
     if (nyb>255 || nyb<0) nyb=255;

     dest[offset++]=envmap[nxb+(nyb << 8)];
     }
   }

//WaitRetrace();
}
while(!kbhit());
fps.stop();
getch();
RestorePal();
printf("\r*** FPS REPORT ***\n");
printf("secondes coules: %f\n",fps.time());
printf("frames affiches: %d\n",frame);
printf("frame/seconde: %f\n",frame/fps.time());
getch();
}