#include "graphics.h"
#include "conio.h"
#include "stdio.h"
#include "dos.h"
#include "process.h"
#include "CTYPE.H"
#include "math.h"
#include "stdlib.h"
#define GRAVEDAD 9.8
#define MINX 20 //Punto minimo x en Pantalla
#define MINY 20 //Punto minimo y en Pantalla
#define MAXX 620 //Punto maximo x en Pantalla
#define MAXY 460 //Punto maximo y en Pantalla
#define RADIO 10

void botonundido(int x, int y, int ancho, int alto, char texto[]);
void botonnoundido(int x, int y, int ancho, int alto, char texto[]);
void mover(float masa, float r1, float r2, float Vm);
void datos(int a, float *b);
void primero (void);
void segundo (void);
void botonundido1(int x, int y, int ancho, int alto, char texto[]);
void botonnoundido1(int x, int y, int ancho, int alto, char texto[]);
void canon1(int x,int y);
void canon2(int x,int y);
void tercero (void);
void iniciargraficos1();
void juego();
void datos1(int a, float *b);
void disparar(int canon, float vo, float ang, int hc1, int hc2);
void explotarcanon(int canon, int hdc);
int presentacion (void);
void opcion (void);
void main (void)
{
	opcion();
}

void opcion (void)
{
	int op;
	int gdriver = DETECT, gmode, errorcode;

	do{
		initgraph(&gdriver, &gmode, "c:\\bor\\turbo5\\bgi");

		/* read result of initialization */
		errorcode = graphresult();
		if (errorcode != grOk) /* an error occurred */
		{
			printf("Graphics error: %s\n", grapherrormsg(errorcode));
			printf("Press any key to halt:");
			getch();
			exit(1); /* terminate with an error code */
		}

		cleardevice();
		op=presentacion();

		switch(op)
		{
			case 59:
				primero();
				closegraph();
				break;

			case 60:
				segundo();
				closegraph();
				break;

			case 61:
				tercero();
				closegraph();
				break;

			case 27:
				closegraph();
				exit(0);
				break;
		}
	}

	while(op!=27);
}


int presentacion (void)
{
	int op;

	setfillstyle(1,BLUE);
	bar(0,0,650,500);
	setfillstyle(1,BLACK);
	bar(160,160,460,310);
	setfillstyle(1,23);
	bar3d(150,150,450,300,0,0);
	setcolor(BLACK);
	setfillstyle(1,24);
	bar(151,151,449,170);
	setcolor(WHITE);
	outtextxy(200,158,"M E N U P R I N C I P A L");
	setcolor(BLACK);
	outtextxy(200,200,"F1 MOVIMIENTO CIRCULAR UNIFORME");
	outtextxy(200,220,"F2 LANZAMIENTO DE PROYECTILES");
	outtextxy(200,240,"F3 CAIDA LIBRE");
	outtextxy(200,260,"Esc SALIR");
	outtextxy(170,285,"ENTRE OPCION");
	op=toupper(getche());
	return(op);
}

void primero (void)
{
	int tecla;
	float r1=-1, r2=-1, masa=-1, Vm=-1; //se le dan valores de -1 a las variables

	cleardevice(); //pues si el usuario no entra
	iniciargraficos1(); //ningun valor el programa no correra.
	setbkcolor(1);
	cleardevice();
	botonnoundido(50,70,100,30,"<M>asa"); //los datos que se le pasan a estas
	botonnoundido(160,70,100,30,"Radio<1>");//funciones, son los valores de
	botonnoundido(270,70,100,30,"Vmini<V>");//altura, ancho,posicion y texto
	botonnoundido(380,70,100,30,"Radio<2>");//de los cuadros de menu.
	botonnoundido(490,70,100,30,"<E>mpezar");
	do
	{
		do
		{
			tecla=getch();
		}while((tecla!='e')&&(tecla!='E')&&(tecla!='M')&&(tecla!='m')&&(tecla!='V')&&(tecla!='v')&&(tecla!='1')&&(tecla!='2')&&(tecla!=27));

		switch(tecla) //este ciclo verifica la opcion y si es verdadera
		{ //llama a la respestiva funcion.
			case 'v':
			case 'V':
				botonundido(390,160,100,30,"Vmini<V>");
				delay(200);
				botonnoundido(390,160,100,30,"Vmini<V>");
				datos(7,&Vm);
				break;

			case 'M':
			case 'm':
				botonundido(390,160,100,30,"<M>asa");
				delay(200);
				botonnoundido(390,160,100,30,"<M>asa");
				datos(1,&masa);
				break;

			case '1':
				botonundido(390,160,100,30,"Radio<1>");
				delay(200);
				botonnoundido(390,160,100,30,"Radio<1>");
				datos(2,&r1);
				break;

			case '2':
				botonundido(390,160,100,30,"Radio<2>");
				delay(200);
				botonnoundido(390,160,100,30,"Radio<2>");
				datos(3,&r2);
				break;

			case 'E':
			case 'e':
				botonundido(490,70,100,30,"<E>mpezar");
				delay(200);
				botonnoundido(490,70,100,30,"<E>mpezar");
				if((masa!=-1)&&(r1!=-1)&&(r2!=-1))
				mover(masa,r1,r2,Vm);
				break;

			case 27:
				opcion();
		}
	}while(1);

}
 

void botonundido(int x, int y, int ancho, int alto, char texto[])
{
	int cuadro[8];

	setfillstyle(1,14);
	cuadro[0]=x;
	cuadro[1]=y;
	cuadro[2]=x+ancho;
	cuadro[3]=y;
	cuadro[4]=x+ancho; //grafica el cuadro menu undido.
	cuadro[5]=y+alto;
	cuadro[6]=x;
	cuadro[7]=y+alto;
	fillpoly(4, cuadro);
	setcolor(2);
	line(x,y+1,x+ancho,y+1);
	line(x+1,y,x+1,y+alto);
	line(x,y,x+ancho,y);
	line(x,y,x,y+alto);
	setcolor(7);
	line(x+ancho,y,x+ancho,y+alto);
	line(x,y+alto,x+ancho,y+alto);
	line(x+ancho-1,y,x+ancho-1,y+alto);
	line(x,y+alto-1,x+ancho,y+alto-1);
	setcolor(8);
	settextjustify(CENTER_TEXT,CENTER_TEXT);
	outtextxy(x+ancho/2,y+alto/2, texto);
}

void botonnoundido(int x, int y, int ancho, int alto, char texto[])
{
	int cuadro[8];

	setfillstyle(1,14);
	cuadro[0]=x;
	cuadro[1]=y;
	cuadro[2]=x+ancho;
	cuadro[3]=y;
	cuadro[4]=x+ancho; //grafica el boton menu sin undir.
	cuadro[5]=y+alto;
	cuadro[6]=x;
	cuadro[7]=y+alto;
	fillpoly(4, cuadro);
	setcolor(7);
	line(x,y,x+ancho,y);
	line(x,y,x,y+alto);
	line(x+1,y+1,x+ancho,y+1);
	line(x+1,y+1,x+1,y+alto);
	setcolor(2);
	line(x+ancho,y,x+ancho,y+alto);
	line(x,y+alto,x+ancho,y+alto);
	line(x+ancho-1,y,x+ancho-1,y+alto);
	line(x,y+alto-1,x+ancho,y+alto-1);
	setcolor(8);
	settextjustify(CENTER_TEXT,CENTER_TEXT); //se necesita declarar un espacio de texto,
	outtextxy(x+ancho/2,y+alto/2, texto); //en este programa el cual maneja solo graficos.
}

void mover(float masa, float r1, float r2, float Vm)
{
	float d,Fmax=0,Fmin=(masa*(Vm*Vm)/r1)+masa*9.8,velr2=sqrt(9.8*r2);
	float l,g; //calculo con formulas y datos entrados.
	int i,j,y,move=1;
	char texto[20];

	cleardevice();

	g=((velr2*velr2)*masa)/r2;
	l=g+(masa*9.8);
	gotoxy(25,5);
	printf("<<MOVIMINETO CIRCULAR NO UNIFORME>>");
	setcolor(14);
	circle(200+r1,240,r1);
	circle(200+r1*2+r2,240,r2); //gradua dependiendo de los radios, las
	line(200+r1,240,200+r1,240+r1); //circuferencias donde pasara la trayectoria
	line(200+r1*2+r2,240,200+r1*2+r2,240-r2); //del carro.
	setcolor(2);
	setlinestyle(0,1,3);
	arc(100,240,0,120,100);
	arc(200+r1,240,180,360,r1);
	arc(200+r1*2+r2,240,0,180,r2);
	setlinestyle(0,1,1);
	setcolor(4);
	moveto(100,240);

	for(i=0;i<=640;i++)
	{
		for(j=0;j<=480;j++)
		{
			if(move==1)
			moveto(i,j);

			if(getpixel(i,j+5)==2)
			{
				move=0;
				lineto(i,j); //maneja la trayectoria (linea) que recorre en el circulo.
				sound(j*3); //esta sentencia permite el sonido en el programa.
				delay(20);
				break;
			}
		}

		if(i==100)
		{
			int y=gety();
			sprintf(texto, "Masa: %0.0fKg", masa);
			outtextxy(i,j-10, texto);
			moveto(i,y);
		}

		if(i==(200+r1))
		{
			int y=gety();
			sprintf(texto, "Fr-min: %0.1fN",Fmin);
			outtextxy(i,j+30, texto);
			sprintf(texto, "Vmin: %0.1fm/s",Vm); //como se ha visto en el programa
			outtextxy(i,j+40, texto); //a medida que recorre la trayectoria
			moveto(i,y); //en el punto maximo y minimo,muestra
		} //los datos correspondientes, fuerza, velocidad.

		if(i==(200+r1*2+r2))
		{
			y=gety();

			if(velr2<0)
			{
				outtextxy(i,y-30,"Hasta aca no llega");
			}
			else
			{
				sprintf(texto, "Vmax: %0.1fm/s", velr2);
				outtextxy(i,j-22, texto);
				sprintf(texto,"F-max %0.1lfN",l);
				outtextxy(i,j-12,texto);
			}

			moveto(i,y);
		}
	}
	nosound();
	getch();
	exit(1);
}

void datos (int a, float *b) //recibe y almacena los datos del usuario.
{
	setcolor(2);
	setlinestyle(0,0,3);
	rectangle(100,200,500,280);
	setlinestyle(0,0,1);
	setfillstyle(1,0);
	bar(101,201,499,279);
	setcolor(15);
	if(a==1)
	{
		gotoxy(40,15);
		outtextxy(234,230,"Digite la Masa (Kg): ");
	}
	else
	{
		if(a==7)
		{
			gotoxy(40,15);
			outtextxy(220,230,"Velocidad minima (m/s): ");
		}
		else
		{
			if(a==2)
			{
				gotoxy(41,15);
				outtextxy(250,230,"Digite el radio1: ");
			}
			else
			{
				gotoxy(41,15);
				outtextxy(250,230,"Digite el radio2: ");
			}
		}
	}
	if(a==1)
	{
		scanf("%f", b);
		if(*b<=0)
		{
			outtextxy(250,250,"Masa incorrecto");
			getch();
			*b=-1;
		}
	}
	if(a==7)
	{
		scanf("%f", b);
		if(*b<=0)
		{
			outtextxy(250,250,"velocidad incorrecta");
			getch();
			*b=-1;
		}
	}
	if(a==2)
	{
		scanf("%f", b);
		if(*b<=0)
		{
			outtextxy(250,250,"Radio1 incorrecto");
			getch();
			*b=-1;
		}
	}
	if(a==3)
	{
		scanf("%f", b);
		if(*b<=0)
		{
			outtextxy(250,250,"Radio2 incorrecto");
			getch();
			*b=-1;
		}
	}
	setfillstyle(1,getbkcolor());
	bar(90,160,510,290);
}

void segundo (void)
{
	int teclapresionada;

	randomize();
	iniciargraficos1();
	settextstyle(4,0,2);
	juego();
}

void iniciargraficos1()
{
	int gdriver=DETECT, gmode, error;

	initgraph(&gdriver, &gmode, "c:\\borlandc\\bgi");
	error=graphresult();
	if(error!=0)
	{
		printf("Error al iniciar los graficos.\nPresione alguna tecla para continuar.");
		getch();
		exit(0);
	}
}

void juego()
{
	int turno=1, tecla, permiso=0, ganador;
	float hc1, hc2;
	float vo=0, ang=-1;

	hc1=random(420)+10;
	delay(5);
	hc2=random(420)+10;
	cambiarturno:
	setfillstyle(7,RED);
	bar(0,0,640,480);
	setcolor(23);
	canon1(30,hc1);
	canon2(590,hc2);
	do
	{
		botonnoundido1(140, 30, 100, 30, "(A)ngulo");
		botonnoundido1(260, 30, 100, 30, "(V). inicial");
		botonnoundido1(380, 30, 100, 30, "(D)isparar");
		do
		{
			tecla=getch();
		}while((tecla!='A')&&(tecla!='a')&&(tecla!='v')&&(tecla!='V')&&(tecla!='d')&&(tecla!='D')&&(tecla!=27)&&(tecla!='r')&&(tecla!='R'));
		switch(tecla)
		{
			case 'A':
			case 'a':
				botonundido1(140, 30, 100, 30, "(A)ngulo");
				delay(200);
				botonnoundido1(140, 30, 100, 30, "(A)ngulo");
				delay(200);
				datos1(1,&ang);
				break;
			case 'V':
			case 'v':
				botonundido1(260, 30, 100, 30, "(V). inicial");
				delay(200);
				botonnoundido1(260, 30, 100, 30, "(V). inicial");
				delay(200);
				datos1(2,&vo);
				break;
			case 'D':
			case 'd':
				botonundido1(380, 30, 100, 30, "(D)isparar");
				delay(200);
				botonnoundido1(380, 30, 100, 30, "(D)isparar");
				delay(200);
				if((ang!=-1)&&(vo!=0)) permiso=1;
				break;
			case 'r':
			case 'R':
				juego();
			case 27:
				opcion();
		}
	}while(permiso!=1);
	disparar(turno, vo, ang, hc1, hc2);
	permiso=0;
	if(turno==1) turno=2;
	else turno=1;

	goto cambiarturno;
}

void botonundido1(int x, int y, int ancho, int alto, char texto[])
{
	int cuadro[8];

	setfillstyle(1,23);

	cuadro[0]=x;
	cuadro[1]=y;
	cuadro[2]=x+ancho;
	cuadro[3]=y;
	cuadro[4]=x+ancho;
	cuadro[5]=y+alto;
	cuadro[6]=x;
	cuadro[7]=y+alto;
	fillpoly(4, cuadro);
	setcolor(BLUE);
	line(x,y,x+ancho,y);
	line(x,y,x,y+alto);
	setcolor(BLUE);
	line(x+ancho,y,x+ancho,y+alto);
	line(x,y+alto,x+ancho,y+alto);
	line(x+ancho-1,y,x+ancho-1,y+alto);
	line(x,y+alto-1,x+ancho,y+alto-1);
	setcolor(BLUE);
	settextjustify(CENTER_TEXT,CENTER_TEXT);
	outtextxy(x+ancho/2,y+alto/2, texto);
}

void botonnoundido1(int x, int y, int ancho, int alto, char texto[])
{
	int cuadro[8];

	setfillstyle(1,23);

	cuadro[0]=x;
	cuadro[1]=y;
	cuadro[2]=x+ancho;
	cuadro[3]=y;
	cuadro[4]=x+ancho;
	cuadro[5]=y+alto;
	cuadro[6]=x;
	cuadro[7]=y+alto;
	fillpoly(4, cuadro);
	setcolor(15);
	line(x,y,x+ancho,y);
	line(x,y,x,y+alto);
	line(x+1,y+1,x+ancho,y+1);
	line(x+1,y+1,x+1,y+alto);
	setcolor(RED);
	line(x+ancho,y,x+ancho,y+alto);
	line(x,y+alto,x+ancho,y+alto);
	setcolor(15);
	settextjustify(CENTER_TEXT,CENTER_TEXT);
	outtextxy(x+ancho/2,y+alto/2, texto);
}

void canon1(int x,int y)
{
	int tubo[8], base[8];

	setfillstyle(1,23);

	tubo[0]=x+37;
	tubo[1]=y+10;
	tubo[2]=x+40;
	tubo[3]=y+15;
	tubo[4]=x+20;
	tubo[5]=y+25;
	tubo[6]=x+15;
	tubo[7]=y+20;

	fillpoly(4,tubo);
	setfillstyle(1,BLACK);

	base[0]=x+0;
	base[1]=y+35;
	base[2]=x+40;
	base[3]=y+35;
	base[4]=x+40;
	base[5]=y+40;
	base[6]=x+0;
	base[7]=y+40;

	fillpoly(4,base);
	setfillstyle(1,BLUE);
	fillellipse(x+20,y+25,10,10);
	setfillstyle(1,0);
	fillellipse(x+20,y+25,3,3);
}

void canon2(int x,int y)
{
	int tubo[8], base[8];

	setfillstyle(1,23);

	tubo[0]=x+3;
	tubo[1]=y+10;
	tubo[2]=x;
	tubo[3]=y+15;
	tubo[4]=x+20;
	tubo[5]=y+25;
	tubo[6]=x+25;
	tubo[7]=y+20;

	fillpoly(4,tubo);
	setfillstyle(1,BLACK);

	base[0]=x+40;
	base[1]=y+35;
	base[2]=x+0;
	base[3]=y+35;
	base[4]=x+0;
	base[5]=y+40;
	base[6]=x+40;
	base[7]=y+40;

	fillpoly(4,base);
	setfillstyle(1,BLUE);
	fillellipse(x+20,y+25,10,10);
	setfillstyle(1,0);
	fillellipse(x+20,y+25,3,3);
}

void datos1 (int a, float *b)
{
	setcolor(7);
	rectangle(100,200,500,280);
	setfillstyle(1,0);
	bar(101,201,499,279);

	if(a==1)
	{
		gotoxy(25,15);
		printf("Digite el angulo (0 a 89): ");
	}
	else
	{
		gotoxy(16,15);
		printf("Digite la velocidad inicial (mayor que 0): ");
	}

	if(a==1)
	{
		scanf("%f", b);
		if((*b<0)||(*b>89))
		{
			gotoxy(25,16);
			printf("Angulo Incorrecto");
			getch();
			*b=-1;
		}
	}

	if(a==2)
	{
		scanf("%f", b);
		if(*b<=0)
		{
			gotoxy(25,16);
			printf("V. Inicial Incorrecta");
			getch();
			*b=0;
		}
	}
	setfillstyle(7,RED);
	bar(100,200,500,280);
}

void disparar(int canon, float vo, float ang, int hc1, int hc2)
{
	int i;
	float y, g=9.8, dist;

	setfillstyle(7,RED);
	bar(100,0,550,200);
	ang=ang*3.1416/180;
	setcolor(GREEN);
	if(canon==1)
	{
		moveto(50,hc1-y+20);
		for(i=30;i<=640;i++)
		{
			dist=i-30;
			y=(dist*tan(ang))-((g*dist*dist)/(2*vo*vo*cos(ang)*cos(ang)));
			y=hc1-y+20;
			lineto(i+20,y);
			if((i>=580)&&(i<600)&&(y>=hc2+15)&&(y<=hc2+35))
			{
				explotarcanon(2,hc2);
				break;
			}
			if(y>480) break;
			delay(10);
		}
	}
	else
	{
		if(canon==2)
		{
			moveto(610,hc2-y+20);
			for(i=590;i>=-100;i--)
			{
				dist=-(i-590);
				y=(dist*tan(ang))-((g*dist*dist)/(2*vo*vo*cos(ang)*cos(ang)));
				y=hc2-y+20;
				lineto(i+20,y);
				if((i>=20)&&(i<=40)&&(y>=hc1+15)&&(y<=hc1+35))
				{
					explotarcanon(1,hc1);
					getch();
					break;
				}
				if(y>480) break;
				delay(10);
			}
		}
	}
}

void explotarcanon(int canon, int hdc)
{
	int i, color, st, tecla;

	setcolor(8);
	for(i=0;i<=300;i++)
	{
		st=random(2);

		if(st==1) setfillstyle(1,4);
		else setfillstyle(1,14);

		if(canon==1) fillellipse(30+random(40),hdc+random(40), random(3)+3, random(3)+3);
		else fillellipse(590+random(40),hdc+random(40), random(3)+3, random(3)+3);

		sound(random(500)+50);
		delay(5);
	}
	nosound();
	setcolor(7);
	rectangle(130,200,500,280);
	setfillstyle(1,0);
	bar(131,201,499,279);
	gotoxy(28,15);
	printf("Desea volver a jugar(S/N): ");
	do
	{
		tecla=getch();
	}while((tecla!='S')&&(tecla!='s')&&(tecla!='N')&&(tecla!='n'));
	if((tecla=='S')||(tecla=='s')) juego();
	else
	{
		closegraph();
		exit(0);
	}
}

int calcular_pendientes(float Dmin_x,float Dmax_x,float Dmin_y,float Dmax_y,float *Pend_x, float *Pend_y)
{
	*Pend_x=(float)(MAXX-MINX)/(Dmax_x-Dmin_x);
	*Pend_y=(float)(MINY-MAXY)/(Dmax_y-Dmin_y);
	return 1;
}

/*Calcula la posicin en pantalla del valor x*/

int x_xp(float x, float pendx, float xmin)
{
	return (int)(pendx*(x-xmin)) + MINX;
}

/*Calcula la posicin en pantalla del valor y*/

int y_yp(float y, float pendy, float ymin)
{
	return (int)(pendy*(y-ymin)) + MAXY;
}

/*Calcula posicin del objeto de acuerdo al tiempo*/

float y_t(float t, float hinicial, float vini)
{
	return t*(vini-0.5*GRAVEDAD*t)+hinicial;
}

/*Calcula Tiempo Mximo Caida*/

float t_max(float hini,float vini)
{
	return (vini+sqrt(vini*vini+2*GRAVEDAD*hini))/GRAVEDAD;
}

/*Calcula Altura Mxima*/

float h_max(float hini,float vini)
{
	return vini*vini/(2*GRAVEDAD)+hini;
}

/*Calcula el tiempo en que la velocidad es cero, tiempo altura mxima*/

float t_h_max(float vini)
{
	return vini/GRAVEDAD;
}

/*Calcula la velocidad*/

float vbola(float t, float vini)
{
	return vini-GRAVEDAD*t;
}

void g_bola(int x,int y, int color)
{
	// int c_a=getcolor();
	setcolor(color);
	circle(x,y,RADIO);
	// setcolor(c_a);
}

int mAnimacion(void)
{
	float i,pex,pey,h,v,hini,vini,tmax,hmax,vsuelo,thmax;
	int px,py,salir=0;
	unsigned tdemora=5;
	char cadena[50];

	do
	{
		cleardevice();;
		textbackground(BLUE);
		textcolor(WHITE);
		cleardevice();
		gotoxy(30,2);
		printf("CAIDA LIBRE\n\n\n");
		printf("Velocidad inicial [m/s]: ");
		scanf("%f",&vini);
		printf("Altura inicial [m] (>=0): ");
		scanf("%f",&hini);
		printf("Retardo para la animacin [ms] (>=0): ");
		scanf("%d",&tdemora);

		if( hini< 0)
		{
			printf("\n\nLa Altura debe ser mayor o igual que cero");
			getch();
		}
		else if(tdemora<0 || tdemora>500)
		{
			printf("\n\nEl tiempo de retardo debe ser mayor o igual que cero y menor de 500");
			getch();
		}
		else
		{
			tmax=t_max(hini,vini);
			hmax=h_max(hini,vini);
			vsuelo=vbola(tmax,vini);
			thmax=t_h_max(vini);
			calcular_pendientes(0,10,0,hmax,&pex,&pey);
			printf("\n\n\n Tiempo de caida: %6.3f [seg]\n",tmax);
			printf(" M xima altura: %6.3f [m]\n",hmax);
			printf(" Tiempo en que se da la maxima altura: %f [seg]\n",thmax); printf(" Velocidad al caer al suelo: %6.3f [m]\n",vsuelo);
			printf("\n Presione una tecla para ver la animacin...");
			getch();
			iniciargraficos1();
			setbkcolor(BLUE);
			bar(0,480-RADIO,639,479);
			setfillstyle(SOLID_FILL,BLUE);
			px=x_xp(5,pex,0);
			py=y_yp(y_t(0,hini,vini),pey,0);
			g_bola(px,py,WHITE);
			outtextxy(2,MINY-15,"Tiempo[s]:");
			gcvt(0,4,cadena);
			outtextxy(90,MINY-15,cadena);
			outtextxy(2,MINY,"Altura[m]:");
			gcvt(hini,4,cadena);
			outtextxy(90,MINY,cadena);
			outtextxy(2,MINY+15,"Vel[m/s]:");
			gcvt(vini,4,cadena);
			outtextxy(90,MINY+15,cadena);
			//gcvt(tmax,4,cadena);
			//outtextxy(2,MINY+15,cadena);
			getch();

			for(i=0; i<=tmax; i+=tmax/100.0)
			{
				px=x_xp(5,pex,0);
				h=y_t(i,hini,vini);
				v=vbola(i,vini);
				py=y_yp(h,pey,0);
				g_bola(px,py,WHITE);
				gcvt(i,4,cadena);
				outtextxy(90,MINY-15,cadena);
				gcvt(h,4,cadena);
				outtextxy(90,MINY,cadena);
				gcvt(v,4,cadena);
				outtextxy(90,MINY+15,cadena);
				delay(tdemora);//Determinar la demora

				if(i<=tmax-tmax/100.0)
				{
					g_bola(px,py,BLUE);
					bar(90,MINY-15,170,MINY+30);
				}
			}
			getch();
			closegraph();
			salir=1;
		}
	}while(!salir);
}

char menu(void)
{
	char opcion;

	cleardevice();gotoxy(10,2);
	printf("Caida Libre");
	gotoxy(5,6);
	printf("1. Calculos y Animacin");
	gotoxy(5,10);
	printf("0. Salir");
	gotoxy(5,12);
	printf("Digite la opcin: ");
	opcion=getch();
	return (opcion-48);
}

void tercero(void)
{
	char opcion;

	textbackground(BLUE);
	textcolor(WHITE);
	opcion=menu();
	while(opcion)
	{
		switch(opcion)
		{
			case 1:
				mAnimacion();
				break;
		}
		opcion=menu();
	}
}