#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <graphics.h>

#define LINHA 	128
#define COLUNA 	128

void main()
{
	int gdriver = DETECT, gmodo, errorcode;
	int i, j, min, max;
	int Img[LINHA][COLUNA];

	clrscr();

	initgraph(&gdriver, &gmodo,"");
	errorcode = graphresult();
	if (errorcode != grOk)	{
			printf("Graphics error: %s\n", grapherrormsg(errorcode));
			printf("Press any key to halt:");
			getch();
			exit(1);
	}
	/*GERA ARRAY*/
	srand(time(NULL));
	for (i=0; i<LINHA; i++)
		for (j=0; j<COLUNA; j++)
			Img[i][j]=rand()%64;
	/*IMPRIME FIGURA*/
	for (i=0; i<LINHA; i++)
		for (j=0; j<COLUNA; j++)
			putpixel(i,j,Img[i][j]);
	getch();

	/*DEFINE MINIMO E MAXIMO*/
	min = max = Img[0][0];
	for (i=0; i<LINHA; i++)
		for (j=0; j<COLUNA; j++)	{
			if (min > Img[i][j])
				min = Img[i][j];
			if (max < Img[i][j])
				max = Img[i][j];
		}

	/*INVERTE ARRAY*/
	for (i=0; i<LINHA; i++)
		for (j=0; j<COLUNA; j++)
			Img[i][j]=53-Img[i][j];
	for (i=0; i<LINHA; i++)
		for (j=0; j<COLUNA; j++)
			putpixel(i,j,Img[i][j]);
	getch();

	/*ADAPTACAO DE ESCALAS*/
	if ((min>0) || (max<53) || ((min>0)&&(max<53)))
		for (i=0; i<LINHA; i++)
			for (j=0; j<COLUNA; j++)
				Img[i][j] = (Img[i][j]*(max-min))/53 + min;

	closegraph();
	getch();

}