#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

int main(void)
{
   /* Solicitacao de auto-detecao e declaracao de variaveis locais*/
   int gdriver = DETECT, gmodo, coderro;
   int xradius = 40, yradius = 40;
   int midx, midy, i;

   /* Inicializacao do modo grafico */
   initgraph(&gdriver, &gmodo, "");

   /* Leitura do resultado do processo de inicializacao */
   coderro = graphresult();
   if (coderro != grOk)  /* Ocorrencia de erro */
   {
      printf("Erro: %s\n", grapherrormsg(coderro));
      printf("Pressione qualquer tecla para sair:");
      getch();
      exit(1); /* Finalizacao com erro */
   }

   midx = getmaxx()/8;
   midy = getmaxy()/8;

   for (i = EMPTY_FILL; i < USER_FILL; i++) {
      setcolor(i);
      setfillstyle(i,i);

      /* Tracado de uma elipse preenchida*/
      fillellipse(midx*i/2, midy*i/2, xradius*i*i/(3+2*i), yradius*i*i/(4+i*i));
      delay(300);
      cleardevice();
   }
   getch();
   closegraph();

   return 0;
}

